"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _find2 = _interopRequireDefault(require("lodash/find"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react2 = _interopRequireDefault(require("auto-bind/react"));

var _reactBootstrap = require("react-bootstrap");

var _reactDebounceInput = _interopRequireDefault(require("react-debounce-input"));

var _reactDom = require("react-dom");

var _Left = _interopRequireDefault(require("./Left"));

var _Right = _interopRequireDefault(require("./Right"));

var _classnames = _interopRequireDefault(require("classnames"));

var _const = require("./const");

require("./style.scss");

var _excluded = ["className", "debounceTimeout", "children"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var ActionInput = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(ActionInput, _Component);

  var _super = _createSuper(ActionInput);

  function ActionInput(props) {
    var _this;

    (0, _classCallCheck2["default"])(this, ActionInput);
    _this = _super.call(this, props);
    (0, _react2["default"])((0, _assertThisInitialized2["default"])(_this));
    _this.state = {
      leftActionComponent: null,
      rightActionComponent: null
    };
    _this.actionInputControlRef = /*#__PURE__*/(0, _react.createRef)();
    return _this;
  }

  (0, _createClass2["default"])(ActionInput, [{
    key: "componentWillMount",
    value: function componentWillMount() {
      var children = this.props.children;
      this.updateComponentsFromProps(children);
    }
  }, {
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      if (this.props.children !== nextProps.children) {
        this.updateComponentsFromProps(nextProps.children);
      }
    }
  }, {
    key: "getComponent",
    value: function getComponent(children, key) {
      return (0, _find2["default"])(_react["default"].Children.toArray(children), function (component) {
        return component.type.side === key;
      });
    }
  }, {
    key: "focus",
    value: function focus() {
      (0, _reactDom.findDOMNode)(this.actionInputControlRef.current).focus();
    }
  }, {
    key: "updateComponentsFromProps",
    value: function updateComponentsFromProps(children) {
      this.setState({
        leftActionComponent: this.getComponent(children, _const.SIDES.LEFT),
        rightActionComponent: this.getComponent(children, _const.SIDES.RIGHT)
      });
    }
  }, {
    key: "render",
    value: function render() {
      // eslint-disable-next-line no-unused-vars
      var _this$props = this.props,
          className = _this$props.className,
          debounceTimeout = _this$props.debounceTimeout,
          children = _this$props.children,
          otherProps = (0, _objectWithoutProperties2["default"])(_this$props, _excluded);
      var hasLeftComponent = !!this.state.leftActionComponent;
      var hasRightComponent = !!this.state.rightActionComponent;
      var classes = (0, _classnames["default"])('action-input', className, {
        'has-left-icon': hasLeftComponent,
        'has-right-icon': hasRightComponent
      });
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: classes
      }, /*#__PURE__*/_react["default"].createElement(_reactBootstrap.FormGroup, null, hasLeftComponent && this.state.leftActionComponent, /*#__PURE__*/_react["default"].createElement(_reactDebounceInput["default"], (0, _extends2["default"])({
        ref: this.actionInputControlRef,
        className: "action-input__form form-control",
        debounceTimeout: debounceTimeout
      }, otherProps)), hasRightComponent && this.state.rightActionComponent));
    }
  }]);
  return ActionInput;
}(_react.Component);

ActionInput.propTypes = {
  className: _propTypes["default"].string,
  type: _propTypes["default"].string.isRequired,
  children: _propTypes["default"].node,
  debounceTimeout: _propTypes["default"].number
};
ActionInput.defaultProps = {
  debounceTimeout: 500
};
ActionInput.Left = _Left["default"];
ActionInput.Right = _Right["default"];
var _default = ActionInput;
exports["default"] = _default;