"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _uniqueId2 = _interopRequireDefault(require("lodash/uniqueId"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _fontIcon = _interopRequireDefault(require("../font-icon"));

var _dropdown = _interopRequireDefault(require("../dropdown"));

require("./style.scss");

function stopEventPropagation(e) {
  e.stopPropagation();
}
/**
 * Wrapper component for all action menus, renders a three dots dropdown
 * Expects Dropdown.Menu as children
 * @param className
 * @param children
 * @constructor
 */


function ActionsMenu(_ref) {
  var className = _ref.className,
      children = _ref.children;
  var classes = (0, _classnames["default"])('actions-menu', className);
  var menuId = (0, _uniqueId2["default"])('actions-menu-');
  return /*#__PURE__*/_react["default"].createElement(_dropdown["default"], {
    className: classes,
    id: menuId,
    onClick: stopEventPropagation
  }, /*#__PURE__*/_react["default"].createElement(_fontIcon["default"], {
    bsRole: "toggle",
    name: "more",
    size: "24px"
  }), /*#__PURE__*/_react["default"].createElement(_dropdown["default"].Menu, null, children));
}

ActionsMenu.propTypes = {
  id: _propTypes["default"].string,
  className: _propTypes["default"].string,
  children: _propTypes["default"].node
};
var _default = ActionsMenu;
exports["default"] = _default;