"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react2 = _interopRequireDefault(require("auto-bind/react"));

var _reactBootstrap = require("react-bootstrap");

var _classnames = _interopRequireDefault(require("classnames"));

var _switch = _interopRequireDefault(require("../switch"));

var _loader = require("../loader");

require("./style.scss");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

/**
 * Confirm modal allows generic modals for confirmation purposes.
 * It allows simple show by calling refs.show(options).
 */
var ConfirmModal = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(ConfirmModal, _Component);

  var _super = _createSuper(ConfirmModal);

  function ConfirmModal(props) {
    var _this;

    (0, _classCallCheck2["default"])(this, ConfirmModal);
    _this = _super.call(this, props);
    (0, _react2["default"])((0, _assertThisInitialized2["default"])(_this));
    _this.state = {
      id: props.id,
      show: false,
      inProgress: false,
      error: null,
      confirmed: false
    };
    return _this;
  }

  (0, _createClass2["default"])(ConfirmModal, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      // Functions onConfirm and onAbort provided through props can unmount ConfirmModal component
      // (for instance, by navigating to another page). By default, after onConfirm or onAbort actions
      // are completed, component calls 'setState' to hide the Modal. This should be done only if
      // component is still mounted, so 'mounted' state is kept in this property.
      this.mounted = true;
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.mounted = false;
    }
  }, {
    key: "show",
    value: function show(options) {
      // if modal is already opened, do not open it again
      if (this.state.show) {
        return;
      } // merge options and props


      var finalOptions = _objectSpread(_objectSpread({}, this.props), options);

      this.setState(_objectSpread({
        show: true,
        confirmed: false
      }, finalOptions));
    }
  }, {
    key: "hide",
    value: function hide() {
      if (this.mounted) {
        this.setState({
          inProgress: false,
          show: false
        });
      }
    }
  }, {
    key: "handleConfirm",
    value: function handleConfirm() {
      var _this2 = this;

      var _this$state = this.state,
          onConfirm = _this$state.onConfirm,
          onError = _this$state.onError,
          id = _this$state.id,
          explicitConfirmationText = _this$state.explicitConfirmationText,
          requireExplicitConfirmation = _this$state.requireExplicitConfirmation,
          confirmed = _this$state.confirmed;

      if (!onConfirm) {
        this.hide();
        return;
      }

      this.setState({
        inProgress: true
      });
      var shouldReturnConfirmationValue = !!explicitConfirmationText && !requireExplicitConfirmation;
      var onConfirmHandler = shouldReturnConfirmationValue ? onConfirm(id, confirmed) : onConfirm(id);
      Promise.resolve(onConfirmHandler).then(this.hide, function (error) {
        _this2.setState({
          inProgress: false
        });

        if (onError) {
          var resolvedError = onError(error);

          _this2.setState({
            error: resolvedError
          });
        }
      });
    }
  }, {
    key: "handleAbort",
    value: function handleAbort() {
      var _this$state2 = this.state,
          onAbort = _this$state2.onAbort,
          id = _this$state2.id;

      if (!onAbort) {
        this.hide();
        return;
      }

      onAbort(id);
      this.hide();
    }
  }, {
    key: "handleToggleChanged",
    value: function handleToggleChanged() {
      var confirmed = this.state.confirmed;
      this.setState({
        confirmed: !confirmed
      });
    }
  }, {
    key: "render",
    value: function render() {
      var className = this.props.className;
      var _this$state3 = this.state,
          show = _this$state3.show,
          title = _this$state3.title,
          message = _this$state3.message,
          hideConfirmBtn = _this$state3.hideConfirmBtn,
          confirmLabel = _this$state3.confirmLabel,
          confirmBsStyle = _this$state3.confirmBsStyle,
          explicitConfirmationText = _this$state3.explicitConfirmationText,
          requireExplicitConfirmation = _this$state3.requireExplicitConfirmation,
          hideAbortBtn = _this$state3.hideAbortBtn,
          abortLabel = _this$state3.abortLabel,
          abortBsStyle = _this$state3.abortBsStyle,
          inProgress = _this$state3.inProgress,
          error = _this$state3.error,
          confirmed = _this$state3.confirmed;
      var classes = (0, _classnames["default"])('confirm-modal', className);
      var isDisabled = !!explicitConfirmationText && requireExplicitConfirmation && !confirmed;
      return /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Modal, {
        dialogClassName: classes,
        onHide: this.handleAbort,
        show: show
      }, /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Modal.Header, null, /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Modal.Title, null, title)), /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Modal.Body, null, /*#__PURE__*/_react["default"].createElement("div", {
        className: "confirm-modal__message"
      }, message), explicitConfirmationText && /*#__PURE__*/_react["default"].createElement("div", {
        className: "confirm-modal__confirm"
      }, explicitConfirmationText, /*#__PURE__*/_react["default"].createElement(_switch["default"], {
        checked: confirmed,
        onChange: this.handleToggleChanged
      })), error && /*#__PURE__*/_react["default"].createElement(_reactBootstrap.HelpBlock, {
        className: "confirm-modal__error-message text-error"
      }, error)), /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Modal.Footer, null, !hideAbortBtn && /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Button, {
        bsStyle: abortBsStyle,
        onClick: this.handleAbort
      }, abortLabel), !hideConfirmBtn && /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Button, {
        bsStyle: confirmBsStyle,
        onClick: this.handleConfirm,
        disabled: isDisabled
      }, /*#__PURE__*/_react["default"].createElement(_loader.LoaderContainer, {
        isLoading: inProgress
      }, confirmLabel))));
    }
  }]);
  return ConfirmModal;
}(_react.Component);

exports["default"] = ConfirmModal;
ConfirmModal.defaultProps = {
  hideConfirmBtn: false,
  confirmLabel: 'OK',
  confirmBsStyle: 'primary',
  hideAbortBtn: false,
  abortLabel: 'Cancel',
  abortBsStyle: 'default',
  onConfirm: null,
  onAbort: null,
  onError: null,
  inProgress: false,
  error: null
};
ConfirmModal.propTypes = {
  /**
   * Id forwarded to onConfirm and onAbort actions.
   */
  id: _propTypes["default"].string,

  /**
   * Add custom className to component
   */
  className: _propTypes["default"].string,

  /**
   * Title of confirm modal content
   */
  title: _propTypes["default"].string,

  /**
   * Content of modal, it can be simple string or component
   */
  message: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].object]),

  /**
   * Flag for showing/hiding confirm button
   */
  hideConfirmBtn: _propTypes["default"].bool,

  /**
   * Text inside confirm button
   */
  confirmLabel: _propTypes["default"].string,

  /**
   * Bootstrap style of confirm button
   */
  confirmBsStyle: _propTypes["default"].string,

  /**
   * Flag for showing/hiding abort button
   */
  hideAbortBtn: _propTypes["default"].bool,

  /**
   * Text inside abort button
   */
  abortLabel: _propTypes["default"].string,

  /**
   * Bootstrap style of abort button
   */
  abortBsStyle: _propTypes["default"].string,

  /**
   * Callback function on confirm button click
   */
  onConfirm: _propTypes["default"].func,

  /**
   * Callback function if error occurs after `onConfirm` action
   * If string is returned from this fn, it will be displayed in error block
   */
  onError: _propTypes["default"].func,

  /**
   * Callback function on abort button click
   */
  onAbort: _propTypes["default"].func,

  /**
   * Allow passing inProgress status from outside
   */
  inProgress: _propTypes["default"].bool,

  /**
   * If explicitConfirmationText is passed, modal shows confirm text and confirm toggle
   * Confirm button is disabled until toggle is checked
   */
  explicitConfirmationText: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].object]),

  /**
   * If true, confirm button will be disabled until Switch is set to true.
   * If false, confirm button is enabled at all times, and ConfirmModal component will
   * return the value of Switch component, along of id.
   */
  requireExplicitConfirmation: _propTypes["default"].bool
};