"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _isEmpty2 = _interopRequireDefault(require("lodash/isEmpty"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react2 = _interopRequireDefault(require("auto-bind/react"));

var _reactDatetime = _interopRequireDefault(require("react-datetime"));

var _classnames = _interopRequireDefault(require("classnames"));

var _moment = _interopRequireDefault(require("moment"));

var _reactDebounceInput = _interopRequireDefault(require("react-debounce-input"));

var _fontIcon = _interopRequireDefault(require("../font-icon"));

require("./style.scss");

var _excluded = ["value", "className"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var DateTimePicker = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(DateTimePicker, _Component);

  var _super = _createSuper(DateTimePicker);

  function DateTimePicker(props) {
    var _this;

    (0, _classCallCheck2["default"])(this, DateTimePicker);
    _this = _super.call(this, props);
    (0, _react2["default"])((0, _assertThisInitialized2["default"])(_this));
    var dateFormat = props.dateFormat,
        timeFormat = props.timeFormat;
    var resolvedTimeFormat = !!timeFormat ? " ".concat(timeFormat) : '';
    _this.dateTimeFormat = "".concat(dateFormat).concat(resolvedTimeFormat);
    return _this;
  }

  (0, _createClass2["default"])(DateTimePicker, [{
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      var prevDateFormat = prevProps.dateFormat,
          prevTimeFormat = prevProps.timeFormat;
      var _this$props = this.props,
          dateFormat = _this$props.dateFormat,
          timeFormat = _this$props.timeFormat;

      if (prevDateFormat !== dateFormat || prevTimeFormat !== timeFormat) {
        var resolvedTimeFormat = !!timeFormat ? " ".concat(timeFormat) : '';
        this.dateTimeFormat = "".concat(dateFormat).concat(resolvedTimeFormat);
      }
    }
  }, {
    key: "handleClearSelection",
    value: function handleClearSelection() {
      this.props.onChange('');
    }
  }, {
    key: "renderInput",
    value: function renderInput(props) {
      var _this$props2 = this.props,
          clearable = _this$props2.clearable,
          value = _this$props2.value;
      var renderClearButton = clearable && !(0, _isEmpty2["default"])(value);
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: "date-time-picker__input"
      }, /*#__PURE__*/_react["default"].createElement(_reactDebounceInput["default"], (0, _extends2["default"])({
        className: "form-control",
        debounceTimeout: 1000,
        type: "text"
      }, props)), renderClearButton && /*#__PURE__*/_react["default"].createElement(_fontIcon["default"], {
        name: "close",
        onClick: this.handleClearSelection,
        size: "16px"
      }));
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props3 = this.props,
          value = _this$props3.value,
          className = _this$props3.className,
          otherProps = (0, _objectWithoutProperties2["default"])(_this$props3, _excluded);
      var classes = (0, _classnames["default"])('date-time-picker', className);

      if (!value) {
        return /*#__PURE__*/_react["default"].createElement(_reactDatetime["default"], (0, _extends2["default"])({
          className: classes,
          renderInput: this.renderInput
        }, this.props));
      }

      var momentValue = (0, _moment["default"])(value);

      if (!momentValue.isValid()) {
        // eslint-disable-next-line
        console.error("Invalid value provided to DateTimePicker: ".concat(JSON.stringify(value)));
      }

      return /*#__PURE__*/_react["default"].createElement(_reactDatetime["default"], (0, _extends2["default"])({
        className: classes,
        renderInput: this.renderInput,
        value: momentValue.format(this.dateTimeFormat)
      }, otherProps));
    }
  }]);
  return DateTimePicker;
}(_react.Component);

exports["default"] = DateTimePicker;
DateTimePicker.propTypes = {
  dateFormat: _propTypes["default"].oneOf([_propTypes["default"].string, _propTypes["default"].bool]),
  timeFormat: _propTypes["default"].oneOf([_propTypes["default"].string, _propTypes["default"].bool]),
  onChange: _propTypes["default"].func,
  utc: _propTypes["default"].bool,
  className: _propTypes["default"].string,
  value: _propTypes["default"].object,
  clearable: _propTypes["default"].bool
};
DateTimePicker.defaultProps = {
  dateFormat: 'DD MMM YYYY',
  timeFormat: 'hh:mm a',
  utc: true,
  clearable: true
};