"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _react = _interopRequireDefault(require("react"));

var _react2 = _interopRequireDefault(require("auto-bind/react"));

var _reactBootstrap = require("react-bootstrap");

var _reactDom = require("react-dom");

var _classnames = _interopRequireDefault(require("classnames"));

require("./style.scss");

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var EnhancedDropdown = /*#__PURE__*/function (_Dropdown) {
  (0, _inherits2["default"])(EnhancedDropdown, _Dropdown);

  var _super = _createSuper(EnhancedDropdown);

  function EnhancedDropdown(props, context) {
    var _this;

    (0, _classCallCheck2["default"])(this, EnhancedDropdown);
    _this = _super.call(this, props, context);
    (0, _react2["default"])((0, _assertThisInitialized2["default"])(_this));
    _this.state = {
      dropup: _this.props.dropup,
      pullRight: _this.props.pullRight,
      ready: false,
      entered: false
    };
    return _this;
  }

  (0, _createClass2["default"])(EnhancedDropdown, [{
    key: "onEnter",
    value: function onEnter() {
      this.setState({
        entered: true
      });
    }
    /*
     * Opens to bottom left by default; takes dropup and pullRight props in
     * consideration when calculating the new state
     */

  }, {
    key: "updateDropdownState",
    value: function updateDropdownState() {
      var dropdownMenu = (0, _reactDom.findDOMNode)(this).querySelector('.dropdown-menu');
      var overlaps = this.getElementScreenOverlaps(dropdownMenu);
      var overlapsTop = overlaps.overlapsTop,
          overlapsRight = overlaps.overlapsRight,
          overlapsBottom = overlaps.overlapsBottom,
          overlapsLeft = overlaps.overlapsLeft;
      var dropup = overlapsBottom || this.props.dropup && !overlapsTop;
      var pullRight = overlapsLeft || this.props.pullRight && !overlapsRight;
      this.setState({
        dropup: dropup,
        pullRight: pullRight,
        ready: true
      });
      requestAnimationFrame(this.onEnter);
    }
  }, {
    key: "onDropdownToggle",
    value: function onDropdownToggle(open) {
      // call the outer level toggle function, if supplied
      if (typeof this.props.onToggle === 'function') {
        this.props.onToggle.call(this, open);
      }

      if (!open) {
        return;
      }
      /**
       * These need to be reset to default values to assure dropdown's
       * default positioning (on which we base the calculations)
       */


      this.setState({
        dropup: this.props.dropup,
        pullRight: this.props.pullRight,
        ready: false,
        entered: false
      });
      /**
       * The only way to make sure that a callback is executed after a node
       * has been both attached to DOM _and_ painted
       */

      requestAnimationFrame(this.updateDropdownState);
    }
    /**
     * Returns the amount of pixels scrolled,
     * both horizontally and vertically
     */

  }, {
    key: "getDocumentScrollOffset",
    value: function getDocumentScrollOffset() {
      var w = window;
      var h = document.documentElement;
      var b = document.body;
      return {
        x: w.pageXOffset ? w.pageXOffset : Math.max(h.scrollLeft, b.scrollLeft),
        y: w.pageYOffset ? w.pageYOffset : Math.max(h.scrollTop, b.scrollTop)
      };
    }
    /**
     * Returns a bool for each screen edge: true if the element's
     * bounding box is overlaping the screen edge, meaning the element
     * is not completely on screen
     */

  }, {
    key: "getElementScreenOverlaps",
    value: function getElementScreenOverlaps(el) {
      var elRect = el.getBoundingClientRect();
      var bodyRect = document.body.getBoundingClientRect();
      var scrolled = this.getDocumentScrollOffset();
      return {
        overlapsTop: elRect.top < bodyRect.top + scrolled.y,
        overlapsRight: elRect.right > bodyRect.right - scrolled.x,
        overlapsBottom: elRect.bottom > bodyRect.bottom + scrolled.y,
        overlapsLeft: elRect.left < bodyRect.left + scrolled.x
      };
    }
  }, {
    key: "render",
    value: function render() {
      var classNameMap = (0, _classnames["default"])(this.props.className, 'enhanced-dropdown', {
        ready: this.state.ready,
        entered: this.state.entered
      });
      return /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Dropdown, (0, _extends2["default"])({}, this.props, {
        dropup: this.state.dropup,
        pullRight: this.state.pullRight,
        onToggle: this.onDropdownToggle,
        className: classNameMap
      }));
    }
  }]);
  return EnhancedDropdown;
}(_reactBootstrap.Dropdown);

exports["default"] = EnhancedDropdown;