"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _size2 = _interopRequireDefault(require("lodash/size"));

var _isEmpty2 = _interopRequireDefault(require("lodash/isEmpty"));

var _slice2 = _interopRequireDefault(require("lodash/slice"));

var _noop2 = _interopRequireDefault(require("lodash/noop"));

var _get2 = _interopRequireDefault(require("lodash/get"));

var _isString2 = _interopRequireDefault(require("lodash/isString"));

var _isFunction2 = _interopRequireDefault(require("lodash/isFunction"));

var _map2 = _interopRequireDefault(require("lodash/map"));

var _filter2 = _interopRequireDefault(require("lodash/filter"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react2 = _interopRequireDefault(require("auto-bind/react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _reactBootstrap = require("react-bootstrap");

var _components = require("./components");

require("./style.scss");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function extractRequiredProps(rowDescriptors) {
  var requiredDescriptors = (0, _filter2["default"])(rowDescriptors, 'isRequired');
  return (0, _map2["default"])(requiredDescriptors, 'property');
}

function resolveRowKeyGenerator(rowKeyIdentifier) {
  if ((0, _isFunction2["default"])(rowKeyIdentifier)) {
    return rowKeyIdentifier;
  }

  if ((0, _isString2["default"])(rowKeyIdentifier)) {
    return function (row) {
      return (0, _get2["default"])(row, rowKeyIdentifier);
    };
  }

  return _noop2["default"];
}

var EditableTable = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(EditableTable, _Component);

  var _super = _createSuper(EditableTable);

  function EditableTable(props) {
    var _this;

    (0, _classCallCheck2["default"])(this, EditableTable);
    _this = _super.call(this, props);
    (0, _react2["default"])((0, _assertThisInitialized2["default"])(_this));
    var rowDescriptors = props.rowDescriptors,
        rowKeyIdentifier = props.rowKeyIdentifier;
    var requiredProps = extractRequiredProps(rowDescriptors);
    var rowKeyGenerator = resolveRowKeyGenerator(rowKeyIdentifier);
    _this.state = {
      requiredProps: requiredProps,
      rowKeyGenerator: rowKeyGenerator,
      addRowInProgress: false
    };
    return _this;
  }

  (0, _createClass2["default"])(EditableTable, [{
    key: "addNewRow",
    value: function addNewRow() {
      this.setState({
        addRowInProgress: true
      });
    }
  }, {
    key: "closeNewRow",
    value: function closeNewRow() {
      this.setState({
        addRowInProgress: false
      });
    }
  }, {
    key: "handleDeleteRow",
    value: function handleDeleteRow(index) {
      var _this$props = this.props,
          rows = _this$props.rows,
          onRowsUpdated = _this$props.onRowsUpdated,
          onRowDeleted = _this$props.onRowDeleted,
          onRowDeleteClick = _this$props.onRowDeleteClick;
      var rowToDelete = rows[index];

      if ((0, _isFunction2["default"])(onRowDeleteClick)) {
        var proceedWithDeletion = onRowDeleteClick(rowToDelete);

        if (!proceedWithDeletion) {
          return;
        }
      }

      var updatedRows = [].concat((0, _toConsumableArray2["default"])((0, _slice2["default"])(rows, 0, index)), (0, _toConsumableArray2["default"])((0, _slice2["default"])(rows, index + 1)));
      onRowsUpdated(updatedRows);
      onRowDeleted(rowToDelete.id);
    }
  }, {
    key: "handleUpdateRow",
    value: function handleUpdateRow(updatedRow, index) {
      var _this$props2 = this.props,
          rows = _this$props2.rows,
          onRowsUpdated = _this$props2.onRowsUpdated,
          onRowUpdated = _this$props2.onRowUpdated;
      var updatedRows = [].concat((0, _toConsumableArray2["default"])((0, _slice2["default"])(rows, 0, index)), [updatedRow], (0, _toConsumableArray2["default"])((0, _slice2["default"])(rows, index + 1)));
      onRowsUpdated(updatedRows);
      onRowUpdated(updatedRow.id, updatedRow);
    }
  }, {
    key: "handleAddRow",
    value: function handleAddRow(newRow) {
      var _this$props3 = this.props,
          rows = _this$props3.rows,
          onRowsUpdated = _this$props3.onRowsUpdated,
          onRowAdded = _this$props3.onRowAdded;
      var updatedRows = [newRow].concat((0, _toConsumableArray2["default"])(rows));
      onRowsUpdated(updatedRows);
      onRowAdded(newRow);
      this.closeNewRow();
    }
  }, {
    key: "renderTableRow",
    value: function renderTableRow(row, index) {
      var _this$props4 = this.props,
          rowDescriptors = _this$props4.rowDescriptors,
          isStatic = _this$props4.isStatic,
          canUpdate = _this$props4.canUpdate,
          canDelete = _this$props4.canDelete,
          onRowClick = _this$props4.onRowClick,
          onRowUpdateClick = _this$props4.onRowUpdateClick;
      var _this$state = this.state,
          requiredProps = _this$state.requiredProps,
          rowKeyGenerator = _this$state.rowKeyGenerator;
      var rowCanBeUpdated = row.canUpdate || canUpdate;
      var rowCanBeDeleted = row.canDelete || canDelete;
      return /*#__PURE__*/_react["default"].createElement(_components.EditableTableRow, {
        key: rowKeyGenerator(row),
        index: index,
        row: row,
        rowDescriptors: rowDescriptors,
        onRowClick: onRowClick,
        onSaveClick: this.handleUpdateRow,
        onDeleteClick: this.handleDeleteRow,
        onUpdateClick: onRowUpdateClick,
        requiredProps: requiredProps,
        isStatic: isStatic,
        canUpdate: rowCanBeUpdated,
        canDelete: rowCanBeDeleted
      });
    }
  }, {
    key: "renderTableRows",
    value: function renderTableRows(displayEmptyState) {
      var _this2 = this;

      var _this$props5 = this.props,
          rows = _this$props5.rows,
          headers = _this$props5.headers,
          emptyStateText = _this$props5.emptyStateText;
      var emptyRows = (0, _isEmpty2["default"])(rows);

      if (emptyRows && displayEmptyState) {
        return /*#__PURE__*/_react["default"].createElement(_components.TableRowTextPlaceholder, {
          text: emptyStateText,
          colSpan: (0, _size2["default"])(headers)
        });
      }

      return (0, _map2["default"])(rows, function (row, index) {
        return _this2.renderTableRow(row, index);
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props6 = this.props,
          className = _this$props6.className,
          headers = _this$props6.headers,
          rowDescriptors = _this$props6.rowDescriptors;
      var _this$state2 = this.state,
          addRowInProgress = _this$state2.addRowInProgress,
          requiredProps = _this$state2.requiredProps;
      var classes = (0, _classnames["default"])('editable-table', className);
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: classes
      }, /*#__PURE__*/_react["default"].createElement("table", {
        className: "table editable-table__table"
      }, /*#__PURE__*/_react["default"].createElement("thead", null, /*#__PURE__*/_react["default"].createElement("tr", null, (0, _map2["default"])(headers, function (header, index) {
        return /*#__PURE__*/_react["default"].createElement("th", {
          key: index
        }, /*#__PURE__*/_react["default"].createElement(_reactBootstrap.ControlLabel, null, header));
      }))), /*#__PURE__*/_react["default"].createElement("tbody", null, addRowInProgress && /*#__PURE__*/_react["default"].createElement(_components.EditableTableRow, {
        isEditMode: true,
        rowDescriptors: rowDescriptors,
        onSaveClick: this.handleAddRow,
        onDeleteClick: this.closeNewRow,
        requiredProps: requiredProps,
        isStatic: false,
        canUpdate: true,
        canDelete: true
      }), this.renderTableRows(!addRowInProgress))));
    }
  }]);
  return EditableTable;
}(_react.Component);

exports["default"] = EditableTable;
EditableTable.propTypes = {
  /**
   * Array of string values to be used as column headers
   */
  headers: _propTypes["default"].arrayOf(_propTypes["default"].string).isRequired,

  /**
   * Array of descriptors for each cell values.
   * Each descriptor can contain 3 fields:
   *  - `isRequired`: marks value as required, used for inline row editing,
   *                  save btn disabled until value is populated
   *  - `property`: defines property key for extracting cell value from row
   *  - `getDisplayValue`: function that can be used instead of providing `property`.
   *                       input: row, output: display string for current table cell.
   */
  rowDescriptors: _propTypes["default"].arrayOf(_propTypes["default"].object).isRequired,

  /**
   * Array of table rows
   */
  rows: _propTypes["default"].array.isRequired,

  /**
   * Additional class name to be passed to react component
   */
  className: _propTypes["default"].string,

  /**
   * Text to be displayed if table has no rows
   */
  emptyStateText: _propTypes["default"].string,

  /**
   * Serves for providing unique key to each table row.
   * If string, key will be row property with that name.
   * If function, expected signature is (row:Object): String.
   */
  rowKeyIdentifier: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].func]).isRequired,

  /**
   * Function called on every table change.
   * Input param: complete array of rows
   */
  onRowsUpdated: _propTypes["default"].func.isRequired,

  /**
   * Function called when row is added to table.
   * Input param: newly added row
   */
  onRowAdded: _propTypes["default"].func,

  /**
   * Function called when row is deleted from table.
   * Input param: deleted row's id.
   */
  onRowDeleted: _propTypes["default"].func,

  /**
   * Function called when row is updated.
   * Input params: updated row's id, updated row
   */
  onRowUpdated: _propTypes["default"].func,

  /**
   * Function called when row is clicked.
   * Output: clicked row.
   */
  onRowClick: _propTypes["default"].func,

  /**
   * Function called when update button is clicked for specific row.
   * Input params: row
   * Output: bool flag indicating whether selected row should enter edit mode or remain static.
   */
  onRowUpdateClick: _propTypes["default"].func,

  /**
   * Function called when delete button is clicked for specific row.
   * This function overrides default table behaviour (removing selected row from array `rows`,
   * then calling `onRowsUpdated` and `onRowDeleted` prop functions).
   * Input params: row
   */
  onRowDeleteClick: _propTypes["default"].func,

  /**
   * Flag indicating whether rows that are not in
   * edit mode should be displayed as disabled form control
   * or just simple text
   */
  isStatic: _propTypes["default"].bool,

  /**
   * Flag indicating whether any row can be updated
   */
  canUpdate: _propTypes["default"].bool,

  /**
   * Flag indicating whether any row can be deleted
   */
  canDelete: _propTypes["default"].bool
};
EditableTable.defaultProps = {
  rows: [],
  rowKeyIdentifier: 'id',
  onRowsUpdated: _noop2["default"],
  onRowAdded: _noop2["default"],
  onRowUpdated: _noop2["default"],
  onRowDeleted: _noop2["default"],
  onRowUpdateClick: null,
  onRowDeleteClick: null,
  emptyStateText: 'No items yet.',
  isStatic: false,
  canUpdate: true,
  canDelete: true
};