"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = EditableTableActionsCell;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _EditableTableRowButton = _interopRequireDefault(require("./EditableTableRowButton"));

function EditableTableActionsCell(_ref) {
  var inEditMode = _ref.inEditMode,
      onDeleteClick = _ref.onDeleteClick,
      canUpdate = _ref.canUpdate,
      canDelete = _ref.canDelete,
      onEditClick = _ref.onEditClick,
      onSaveClick = _ref.onSaveClick,
      valid = _ref.valid;

  if (!canUpdate && !canDelete) {
    return null;
  }

  var showEditButton = canUpdate && !inEditMode;
  var showSaveButton = canUpdate && inEditMode;
  return /*#__PURE__*/_react["default"].createElement("td", {
    className: "editable-table-actions-cell"
  }, canDelete && /*#__PURE__*/_react["default"].createElement(_EditableTableRowButton["default"], {
    onClick: onDeleteClick,
    iconName: "delete"
  }), showEditButton && /*#__PURE__*/_react["default"].createElement(_EditableTableRowButton["default"], {
    onClick: onEditClick,
    iconName: "edit"
  }), showSaveButton && /*#__PURE__*/_react["default"].createElement(_EditableTableRowButton["default"], {
    onClick: onSaveClick,
    iconName: "check",
    disabled: !valid
  }));
}

EditableTableActionsCell.propTypes = {
  valid: _propTypes["default"].bool,
  inEditMode: _propTypes["default"].bool,
  onDeleteClick: _propTypes["default"].func,
  onSaveClick: _propTypes["default"].func,
  onEditClick: _propTypes["default"].func,
  canUpdate: _propTypes["default"].bool,
  canDelete: _propTypes["default"].bool
};
EditableTableActionsCell.defaultProps = {
  valid: true
};