"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _map2 = _interopRequireDefault(require("lodash/map"));

var _isEmpty2 = _interopRequireDefault(require("lodash/isEmpty"));

var _get2 = _interopRequireDefault(require("lodash/get"));

var _every2 = _interopRequireDefault(require("lodash/every"));

var _isFunction2 = _interopRequireDefault(require("lodash/isFunction"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react2 = _interopRequireDefault(require("auto-bind/react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _EditableTableCell = _interopRequireDefault(require("./EditableTableCell"));

var _EditableTableActionsCell = _interopRequireDefault(require("./EditableTableActionsCell"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var EditableTableRow = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(EditableTableRow, _Component);

  var _super = _createSuper(EditableTableRow);

  function EditableTableRow(props) {
    var _this;

    (0, _classCallCheck2["default"])(this, EditableTableRow);
    _this = _super.call(this, props);
    (0, _react2["default"])((0, _assertThisInitialized2["default"])(_this));
    _this.state = {
      row: props.row,
      inEditMode: props.isEditMode
    };
    return _this;
  }

  (0, _createClass2["default"])(EditableTableRow, [{
    key: "handleEditClick",
    value: function handleEditClick() {
      var _this$props = this.props,
          row = _this$props.row,
          onUpdateClick = _this$props.onUpdateClick;

      if (!(0, _isFunction2["default"])(onUpdateClick)) {
        this.setState({
          row: row,
          inEditMode: true
        });
        return;
      }

      var inEditMode = onUpdateClick(row);
      this.setState({
        row: row,
        inEditMode: inEditMode
      });
    }
  }, {
    key: "handleSaveClick",
    value: function handleSaveClick() {
      var _this$props2 = this.props,
          onSaveClick = _this$props2.onSaveClick,
          index = _this$props2.index;
      var row = this.state.row;
      onSaveClick(row, index);
      this.setState({
        inEditMode: false
      });
    }
  }, {
    key: "handleDeleteClick",
    value: function handleDeleteClick() {
      var _this$props3 = this.props,
          onDeleteClick = _this$props3.onDeleteClick,
          index = _this$props3.index;
      onDeleteClick(index);
    }
  }, {
    key: "handleRowClick",
    value: function handleRowClick() {
      var _this$props4 = this.props,
          onRowClick = _this$props4.onRowClick,
          row = _this$props4.row;

      if ((0, _isFunction2["default"])(onRowClick)) {
        onRowClick(row);
      }
    }
  }, {
    key: "handleInputChange",
    value: function handleInputChange(prop, value) {
      var row = this.state.row;
      this.setState({
        row: _objectSpread(_objectSpread({}, row), {}, (0, _defineProperty2["default"])({}, prop, value))
      });
    }
  }, {
    key: "isRowValid",
    value: function isRowValid() {
      var row = this.state.row;
      var requiredProps = this.props.requiredProps;
      return (0, _every2["default"])(requiredProps, function (prop) {
        var propValue = (0, _get2["default"])(row, prop);
        return !(0, _isEmpty2["default"])(propValue);
      });
    }
  }, {
    key: "renderTableCell",
    value: function renderTableCell(fieldDescriptor) {
      var _this$props5 = this.props,
          row = _this$props5.row,
          isStatic = _this$props5.isStatic;
      var _this$state = this.state,
          inEditMode = _this$state.inEditMode,
          stateRow = _this$state.row;
      var getDisplayValue = fieldDescriptor.getDisplayValue,
          property = fieldDescriptor.property;
      var currentRow = inEditMode ? stateRow : row;
      var value = (0, _isFunction2["default"])(getDisplayValue) ? getDisplayValue(currentRow) : (0, _get2["default"])(currentRow, property);
      return /*#__PURE__*/_react["default"].createElement(_EditableTableCell["default"], {
        key: property,
        propKey: property,
        inEditMode: inEditMode,
        value: value,
        onChange: this.handleInputChange,
        isStatic: isStatic
      });
    }
  }, {
    key: "render",
    value: function render() {
      var inEditMode = this.state.inEditMode;
      var _this$props6 = this.props,
          row = _this$props6.row,
          rowDescriptors = _this$props6.rowDescriptors,
          canUpdate = _this$props6.canUpdate,
          canDelete = _this$props6.canDelete,
          onRowClick = _this$props6.onRowClick;

      if (!inEditMode && !row) {
        return null;
      }

      var rowValid = this.isRowValid();
      var classes = (0, _classnames["default"])('editable-table-row', {
        'editable-table-row-cursor': (0, _isFunction2["default"])(onRowClick)
      });
      return /*#__PURE__*/_react["default"].createElement("tr", {
        className: classes,
        onClick: this.handleRowClick
      }, (0, _map2["default"])(rowDescriptors, this.renderTableCell), /*#__PURE__*/_react["default"].createElement(_EditableTableActionsCell["default"], {
        onDeleteClick: this.handleDeleteClick,
        onSaveClick: this.handleSaveClick,
        onEditClick: this.handleEditClick,
        inEditMode: inEditMode,
        valid: rowValid,
        canUpdate: canUpdate,
        canDelete: canDelete
      }));
    }
  }]);
  return EditableTableRow;
}(_react.Component);

exports["default"] = EditableTableRow;
EditableTableRow.propTypes = {
  row: _propTypes["default"].object,
  rowDescriptors: _propTypes["default"].arrayOf(_propTypes["default"].object).isRequired,
  requiredProps: _propTypes["default"].arrayOf(_propTypes["default"].string),
  index: _propTypes["default"].number,
  onRowClick: _propTypes["default"].func,
  onSaveClick: _propTypes["default"].func,
  onDeleteClick: _propTypes["default"].func,
  onUpdateClick: _propTypes["default"].func,
  isEditMode: _propTypes["default"].bool,
  isStatic: _propTypes["default"].bool,
  canUpdate: _propTypes["default"].bool,
  canDelete: _propTypes["default"].bool
};
EditableTableRow.defaultProps = {
  isEditMode: false,
  requiredProps: [],
  row: {}
};