"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = EmptyResourcePlaceholder;

var _isObject2 = _interopRequireDefault(require("lodash/isObject"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

require("./style.scss");

function EmptyResourcePlaceholder(_ref) {
  var imageSrc = _ref.imageSrc,
      imageSrcSet = _ref.imageSrcSet,
      imageSize = _ref.imageSize,
      title = _ref.title,
      className = _ref.className,
      children = _ref.children;
  var classNameMap = (0, _classnames["default"])('empty-placeholder', className);
  var imageStyle = (0, _isObject2["default"])(imageSize) ? imageSize : {
    width: imageSize,
    height: imageSize
  };
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: classNameMap
  }, imageSrc && /*#__PURE__*/_react["default"].createElement("img", {
    src: imageSrc,
    srcSet: imageSrcSet,
    role: "presentation",
    style: imageStyle
  }), /*#__PURE__*/_react["default"].createElement("h2", null, title), /*#__PURE__*/_react["default"].createElement("div", {
    className: "empty-placeholder__content"
  }, children));
}

EmptyResourcePlaceholder.propTypes = {
  imageSrc: _propTypes["default"].string,
  imageSrcSet: _propTypes["default"].string,

  /**
   * If string, image will be rectangular, both width and height of `imageSize`.
   * If object, it must be have `width` and `height` properties.
   */
  imageSize: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].object]),
  title: _propTypes["default"].string.isRequired,
  className: _propTypes["default"].string,
  children: _propTypes["default"].node
};