"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react2 = _interopRequireDefault(require("auto-bind/react"));

var _urijs = _interopRequireDefault(require("urijs"));

var _classnames = _interopRequireDefault(require("classnames"));

var _fontIcon = _interopRequireDefault(require("../font-icon"));

require("./style.scss");

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var FilePreview = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(FilePreview, _React$Component);

  var _super = _createSuper(FilePreview);

  function FilePreview(props) {
    var _this;

    (0, _classCallCheck2["default"])(this, FilePreview);
    _this = _super.call(this, props);
    (0, _react2["default"])((0, _assertThisInitialized2["default"])(_this));
    return _this;
  }

  (0, _createClass2["default"])(FilePreview, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          src = _this$props.src,
          className = _this$props.className,
          canBeDeleted = _this$props.canBeDeleted,
          onDeleteClick = _this$props.onDeleteClick,
          noFileErrorMessage = _this$props.noFileErrorMessage;
      var filename = src ? new _urijs["default"](src).filename() : noFileErrorMessage;
      var classes = (0, _classnames["default"])(className, 'file-preview', {
        'is-deletable': canBeDeleted
      });
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: classes
      }, /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement(_fontIcon["default"], {
        name: "file-uploaded",
        size: "24px"
      }), /*#__PURE__*/_react["default"].createElement("div", null, filename)), canBeDeleted && /*#__PURE__*/_react["default"].createElement(_fontIcon["default"], {
        name: "delete",
        onClick: onDeleteClick,
        className: "file-preview__delete"
      }));
    }
  }]);
  return FilePreview;
}(_react["default"].Component);

exports["default"] = FilePreview;
FilePreview.propTypes = {
  /**
   * Valid url to the file
   */
  src: _propTypes["default"].string.isRequired,

  /**
   * Additional classes to apply
   */
  className: _propTypes["default"].string,

  /**
   * Click handler for delete icon
   */
  onDeleteClick: _propTypes["default"].func,

  /**
   * Flag indicating whether file can be deleted
   */
  canBeDeleted: _propTypes["default"].bool,

  /**
   * No file error message
   */
  noFileErrorMessage: _propTypes["default"].string
};