"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _noop2 = _interopRequireDefault(require("lodash/noop"));

var _get2 = _interopRequireDefault(require("lodash/get"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react2 = _interopRequireDefault(require("auto-bind/react"));

var _reactBootstrap = require("react-bootstrap");

var _reactDropzone = _interopRequireDefault(require("react-dropzone"));

var _classnames = _interopRequireDefault(require("classnames"));

var _filePreview = _interopRequireDefault(require("../file-preview"));

var _fileUploadPlaceholder = _interopRequireDefault(require("../file-upload-placeholder"));

var _loader = require("../loader");

require("./style.scss");

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var FileUploader = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(FileUploader, _React$Component);

  var _super = _createSuper(FileUploader);

  function FileUploader(props) {
    var _this;

    (0, _classCallCheck2["default"])(this, FileUploader);
    _this = _super.call(this, props);
    (0, _react2["default"])((0, _assertThisInitialized2["default"])(_this));
    _this.state = {
      inProgress: false,
      error: null
    };
    return _this;
  }

  (0, _createClass2["default"])(FileUploader, [{
    key: "handleUploadFailed",
    value: function handleUploadFailed(errorMessage) {
      var onError = this.props.onError;
      this.setState({
        error: errorMessage,
        inProgress: false
      });
      onError(errorMessage);
    }
  }, {
    key: "handleUploadSucceeded",
    value: function handleUploadSucceeded(fileUrl) {
      var onUploadSuccess = this.props.onUploadSuccess;
      onUploadSuccess(fileUrl);
      this.setState({
        inProgress: false
      });
    }
  }, {
    key: "validateFileSize",
    value: function validateFileSize(file) {
      var _this$props = this.props,
          localization = _this$props.localization,
          maxFileSize = _this$props.maxFileSize;

      if (file.size > maxFileSize) {
        return localization.fileMaxSizeError;
      }

      return null;
    }
  }, {
    key: "uploadFile",
    value: function uploadFile(file) {
      var _this$props2 = this.props,
          assetManager = _this$props2.assetManager,
          folderName = _this$props2.folderName,
          localization = _this$props2.localization,
          resolveFilename = _this$props2.resolveFilename;
      var resolvedFilename = resolveFilename(file);
      var resolvedFolderPath = folderName ? "".concat(folderName, "/") : '';
      var resolvedPath = resolvedFolderPath + resolvedFilename;
      return new Promise(function (resolve, reject) {
        return assetManager.uploadFile(resolvedPath, file).then(function (path) {
          return resolve(path);
        })["catch"](function () {
          return reject(localization.fileUploadError);
        });
      });
    }
  }, {
    key: "upload",
    value: function upload(file) {
      var _this2 = this;

      var customValidator = this.props.customValidator;
      return new Promise(function (resolve, reject) {
        var fileSizeError = _this2.validateFileSize(file);

        if (fileSizeError) {
          return reject(fileSizeError);
        }

        if (customValidator) {
          return Promise.resolve().then(function () {
            return customValidator(file);
          }).then(function () {
            return _this2.uploadFile(file);
          }).then(function (resolvedPath) {
            return _this2.handleUploadSucceeded(resolvedPath);
          })["catch"](function (e) {
            return _this2.handleUploadFailed(e.message);
          });
        }

        return _this2.uploadFile(file).then(function (resolvedPath) {
          return _this2.handleUploadSucceeded(resolvedPath);
        })["catch"](function (e) {
          return _this2.handleUploadFailed(e.message);
        });
      });
    }
  }, {
    key: "handleDrop",
    value: function handleDrop(files) {
      var onDrop = this.props.onDrop;
      var file = (0, _get2["default"])(files, [0]);

      if (!file) {
        return;
      }

      this.setState({
        inProgress: true,
        error: null
      });
      onDrop();
      this.upload(file).then(this.handleUploadSucceeded)["catch"](this.handleUploadFailed);
    }
  }, {
    key: "handleDropRejected",
    value: function handleDropRejected() {
      var localization = this.props.localization;
      this.setState({
        error: localization.fileRejectedError
      });
    }
  }, {
    key: "handleDeleteFailed",
    value: function handleDeleteFailed() {
      var localization = this.props.localization;
      this.setState({
        error: localization.fileDeleteError,
        inProgress: false
      });
    }
  }, {
    key: "handleDeleteClick",
    value: function handleDeleteClick(event) {
      var _this3 = this;

      event.stopPropagation();
      var _this$props3 = this.props,
          src = _this$props3.src,
          shallowDelete = _this$props3.shallowDelete,
          onDeleteSuccess = _this$props3.onDeleteSuccess,
          assetManager = _this$props3.assetManager;

      if (shallowDelete) {
        return onDeleteSuccess(src);
      }

      this.setState({
        inProgress: true
      });
      return assetManager.deleteFile(src).then(function () {
        _this3.setState({
          inProgress: false
        });

        return onDeleteSuccess(src);
      }, this.handleDeleteFailed);
    }
  }, {
    key: "renderDropzoneContent",
    value: function renderDropzoneContent() {
      var _this$props4 = this.props,
          src = _this$props4.src,
          canBeDeleted = _this$props4.canBeDeleted,
          localization = _this$props4.localization;

      if (!src) {
        return /*#__PURE__*/_react["default"].createElement(_fileUploadPlaceholder["default"], {
          uploadPlaceholderMessage: localization.fileUploadMessage
        });
      }

      return /*#__PURE__*/_react["default"].createElement(_filePreview["default"], {
        src: src,
        canBeDeleted: canBeDeleted,
        noFileErrorMessage: localization.noFileErrorMessage,
        onDeleteClick: this.handleDeleteClick
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this4 = this;

      var _this$props5 = this.props,
          className = _this$props5.className,
          showValidationError = _this$props5.showValidationError,
          helpText = _this$props5.helpText,
          accept = _this$props5.accept;
      var _this$state = this.state,
          error = _this$state.error,
          inProgress = _this$state.inProgress;
      var classes = (0, _classnames["default"])(className, 'file-uploader');
      return /*#__PURE__*/_react["default"].createElement(_loader.LoaderContainer, {
        isLoading: inProgress,
        className: classes
      }, /*#__PURE__*/_react["default"].createElement(_reactDropzone["default"], {
        className: "file-uploader__dropzone",
        onDrop: this.handleDrop,
        onDropRejected: this.handleDropRejected,
        multiple: false,
        accept: accept
      }, function (dropzoneProps) {
        return _this4.renderDropzoneContent(dropzoneProps);
      }), showValidationError && error && /*#__PURE__*/_react["default"].createElement("div", {
        className: "text-error"
      }, error), helpText && !error && /*#__PURE__*/_react["default"].createElement(_reactBootstrap.HelpBlock, null, helpText));
    }
  }]);
  return FileUploader;
}(_react["default"].Component);

exports["default"] = FileUploader;
FileUploader.propTypes = {
  /**
   *  Callback invoked when file is dropped and upload starts
   */
  onDrop: _propTypes["default"].func.isRequired,

  /**
   *  Callback invoked when file is uploaded
   */
  onUploadSuccess: _propTypes["default"].func.isRequired,

  /**
   *  Callback invoked when upload fails
   */
  onError: _propTypes["default"].func,

  /**
   * Additional classes to apply
   */
  className: _propTypes["default"].string,

  /**
   * Strings displayed to end users
   */
  localization: _propTypes["default"].object,

  /**
   *  Url to the src
   */
  src: _propTypes["default"].string,

  /**
   * Flag indicating whether to show validation error in component.
   * If set to false, onError function should be provided for displaying upload error.
   */
  showValidationError: _propTypes["default"].bool,

  /**
   * Help text positioned below dropzone
   */
  helpText: _propTypes["default"].string,

  /**
   * Object containing methods for inProgress, listing, and deleting files on cloud
   */
  assetManager: _propTypes["default"].shape({
    deleteFile: _propTypes["default"].func.isRequired,
    uploadFile: _propTypes["default"].func.isRequired,
    listFolder: _propTypes["default"].func.isRequired
  }),
  folderName: _propTypes["default"].string,
  resolveFilename: _propTypes["default"].func,

  /**
   *  Callback forwarded to FilePreview component; invoked when existing file is deleted
   */
  onDeleteSuccess: _propTypes["default"].func,

  /**
   * Flag indicating whether file can be deleted
   */
  canBeDeleted: _propTypes["default"].bool,

  /**
   * By providing accept prop you can make Dropzone to accept
   * specific file types and reject the others.
   */
  accept: _propTypes["default"].string,

  /**
   * Max file size allowed to be uploaded
   */
  maxFileSize: _propTypes["default"].number,

  /**
   * Max file size allowed to be uploaded
   */
  shallowDelete: _propTypes["default"].bool,

  /**
   * Provides a way to perform custom file validation before upload.
   * If you return a promise it will be resolved.
   */
  customValidator: _propTypes["default"].func
};
FileUploader.defaultProps = {
  maxFileSize: 10000000,
  onError: function onError() {},
  localization: {
    fileUploadError: 'File upload failed.',
    fileMaxSizeError: 'Max allowed file size is {{maxFileSize}}MB!',
    fileRejectedError: 'File rejected',
    fileDeleteError: 'Delete failed.',
    noFileErrorMessage: 'No file',
    fileUploadMessage: 'Choose a file or drag it here.'
  },
  customValidator: _noop2["default"],
  showValidationError: true,
  canBeDeleted: true,
  autoResize: true,
  resolveFilename: function resolveFilename(file) {
    return file.name;
  }
};