"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = FontIconPopover;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactBootstrap = require("react-bootstrap");

var _classnames = _interopRequireDefault(require("classnames"));

require("./style.scss");

var _excluded = ["className", "children", "message", "placement", "trigger"];

function renderPopover(message, className) {
  var classes = (0, _classnames["default"])('font-icon-popover__popover', className);
  return /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Popover, {
    id: "font-icon-popover__popover",
    className: classes
  }, message);
}

function FontIconPopover(_ref) {
  var className = _ref.className,
      children = _ref.children,
      message = _ref.message,
      placement = _ref.placement,
      trigger = _ref.trigger,
      props = (0, _objectWithoutProperties2["default"])(_ref, _excluded);
  return /*#__PURE__*/_react["default"].createElement(_reactBootstrap.OverlayTrigger, (0, _extends2["default"])({
    overlay: renderPopover(message, className),
    placement: placement,
    trigger: trigger
  }, props), _react["default"].Children.only(children));
}

FontIconPopover.propTypes = {
  /**
   * Additional class name to be passed to component
   */
  className: _propTypes["default"].string,

  /**
   * FontIcon component that will have popover
   */
  children: _propTypes["default"].node,

  /**
   * Message that will be displayed in popover
   */
  message: _propTypes["default"].node,

  /**
   * Placement of popover in relation to icon
   */
  placement: _propTypes["default"].oneOf(['top', 'right', 'bottom', 'left']),

  /**
   * Action/actions that trigger popover visibility
   */
  trigger: _propTypes["default"].oneOfType([_propTypes["default"].array, _propTypes["default"].string])
};
FontIconPopover.defaultProps = {
  placement: 'right',
  trigger: ['hover', 'focus']
};