"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = FontIcon;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _omit2 = _interopRequireDefault(require("lodash/omit"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _excluded = ["className", "name", "size"];

function FontIcon(_ref) {
  var className = _ref.className,
      name = _ref.name,
      size = _ref.size,
      props = (0, _objectWithoutProperties2["default"])(_ref, _excluded);
  var classNameMap = (0, _classnames["default"])(className, 'se-icon', "se-icon-".concat(name));
  var style = {
    fontSize: size
  };
  var otherProps = (0, _omit2["default"])(props, ['bsStyle', 'bsRole']);
  return /*#__PURE__*/_react["default"].createElement("span", (0, _extends2["default"])({}, otherProps, {
    style: style,
    className: classNameMap
  }));
}

FontIcon.propTypes = {
  /**
   * Ny icon type se-icon-* (iconography)
   */
  name: _propTypes["default"].string.isRequired,

  /**
   * Define size of icon
   */
  size: _propTypes["default"].string,

  /**
   * Additional class name to be passed to react component
   */
  className: _propTypes["default"].string
};
FontIcon.defaultProps = {
  className: '',
  children: []
};