"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = IconLabel;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _FontIcon = _interopRequireDefault(require("./../font-icon/FontIcon"));

require("./style.scss");

var _excluded = ["iconName", "right", "className", "size"];

function IconLabel(_ref) {
  var iconName = _ref.iconName,
      right = _ref.right,
      className = _ref.className,
      size = _ref.size,
      props = (0, _objectWithoutProperties2["default"])(_ref, _excluded);
  var classes = (0, _classnames["default"])(className, 'icon-label');
  var fontIconClasses = (0, _classnames["default"])({
    'icon-label__icon': true,
    'is-left': !right,
    'is-right': right
  });

  var FontIconCmp = /*#__PURE__*/_react["default"].createElement(_FontIcon["default"], {
    name: iconName,
    size: size,
    className: fontIconClasses
  });

  return /*#__PURE__*/_react["default"].createElement("div", {
    className: classes
  }, !right && FontIconCmp, /*#__PURE__*/_react["default"].createElement("span", (0, _extends2["default"])({
    className: "text-ellipsis icon-label__label"
  }, props)), right && FontIconCmp);
}

IconLabel.propTypes = {
  /**
   * Name of the icon from FontIcon font
   */
  iconName: _propTypes["default"].string.isRequired,

  /**
   * Should icon be pulled right-most side
   */
  right: _propTypes["default"].bool,

  /**
   * Additional class name to be passed to react component
   */
  className: _propTypes["default"].string,

  /**
   * Define size of icon
   */
  size: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string])
};
IconLabel.defaultProps = {
  right: false,
  className: ''
};