"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = ImageLabel;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

require("./style.scss");

var _excluded = ["src", "right", "className", "size"];

function ImageLabel(_ref) {
  var src = _ref.src,
      right = _ref.right,
      className = _ref.className,
      size = _ref.size,
      props = (0, _objectWithoutProperties2["default"])(_ref, _excluded);
  var classes = (0, _classnames["default"])(className, 'image-label');
  var imgContainerClasses = (0, _classnames["default"])({
    'image-label__img-container': true,
    'is-left': !right,
    'is-right': right
  });
  var boxSizeStyle = {
    width: size,
    height: size
  };

  var ImgCmp = /*#__PURE__*/_react["default"].createElement("div", {
    style: boxSizeStyle,
    className: imgContainerClasses
  }, /*#__PURE__*/_react["default"].createElement("img", {
    src: src,
    style: boxSizeStyle,
    className: "image-label__image"
  }));

  return /*#__PURE__*/_react["default"].createElement("div", {
    className: classes
  }, !right && ImgCmp, /*#__PURE__*/_react["default"].createElement("span", (0, _extends2["default"])({
    className: "image-label__label"
  }, props)), right && ImgCmp);
}

ImageLabel.propTypes = {
  /**
   * Url of an image
   */
  src: _propTypes["default"].string.isRequired,

  /**
   * Should icon be pulled right-most side
   */
  right: _propTypes["default"].bool,

  /**
   * Additional class name to be passed to react component
   */
  className: _propTypes["default"].string,

  /**
   * Define size of an image
   */
  size: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string])
};