"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactBootstrap = require("react-bootstrap");

var _services = require("../../services");

var _fontIcon = _interopRequireDefault(require("../font-icon"));

var _components = require("./components");

require("./style.scss");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var IMAGE_SEARCH_TAB_TITLE = 'Free images';
var MODAL_TITLE = 'Insert images';

function ImagePickerModal(_ref) {
  var CustomFooterComponent = _ref.CustomFooterComponent,
      customFooterComponentProps = _ref.customFooterComponentProps,
      CustomHeaderComponent = _ref.CustomHeaderComponent,
      customHeaderComponentProps = _ref.customHeaderComponentProps,
      CustomImagesSelectTabComponent = _ref.CustomImagesSelectTabComponent,
      customImagesSelectTabComponentProps = _ref.customImagesSelectTabComponentProps,
      localization = _ref.localization,
      onCloseButtonClick = _ref.onCloseButtonClick,
      onImagesSelected = _ref.onImagesSelected,
      options = _ref.options;
  var footerText = localization.footerText,
      insertButtonTextSingular = localization.insertButtonTextSingular,
      insertButtonTextPlural = localization.insertButtonTextPlural,
      invalidAccessKeyErrorText = localization.invalidUnsplashKeyText,
      imagePreviewOnText = localization.imagePreviewOnText,
      imagePreviewPhotoByText = localization.imagePreviewPhotoByText,
      imagePreviewUnsplashText = localization.imagePreviewUnsplashText,
      maxText = localization.maxText,
      _localization$searchT = localization.searchTabTitle,
      imageSearchTabTitle = _localization$searchT === void 0 ? IMAGE_SEARCH_TAB_TITLE : _localization$searchT,
      _localization$modalTi = localization.modalTitle,
      modalTitle = _localization$modalTi === void 0 ? MODAL_TITLE : _localization$modalTi,
      searchInputPlaceholder = localization.searchPlaceholder;
  var unsplashImagesPickerLocalization = {
    insertButtonTextSingular: insertButtonTextSingular,
    insertButtonTextPlural: insertButtonTextPlural,
    invalidAccessKeyErrorText: invalidAccessKeyErrorText,
    imagePreviewOnText: imagePreviewOnText,
    imagePreviewPhotoByText: imagePreviewPhotoByText,
    imagePreviewUnsplashText: imagePreviewUnsplashText,
    maxText: maxText,
    searchInputPlaceholder: searchInputPlaceholder
  };
  var ResolvedCustomFooterComponent = (0, _services.resolveReactComponent)(CustomFooterComponent, customFooterComponentProps);
  var ResolvedCustomHeaderComponent = (0, _services.resolveReactComponent)(CustomHeaderComponent, customHeaderComponentProps);
  var ResolvedCustomImagesSelectTabComponent = (0, _services.resolveReactComponent)(CustomImagesSelectTabComponent, customImagesSelectTabComponentProps);
  return /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Modal, {
    bsSize: "large",
    show: true
  }, !CustomHeaderComponent && /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Modal.Header, null, /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Modal.Title, null, /*#__PURE__*/_react["default"].createElement("div", {
    className: "image-picker-modal__header-container"
  }, /*#__PURE__*/_react["default"].createElement(_fontIcon["default"], {
    className: "image-picker-modal__close-button",
    name: "close",
    onClick: onCloseButtonClick,
    size: "18px"
  }), modalTitle))), CustomHeaderComponent && ResolvedCustomHeaderComponent, /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Modal.Body, null, /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Tabs, {
    id: "image-picker-modal-tabs",
    className: "image-picker-modal-tabs",
    defaultActiveKey: "3rdPartyImages"
  }, /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Tab, {
    key: "3rdPartyImages",
    eventKey: "3rdPartyImages",
    title: imageSearchTabTitle.toUpperCase()
  }, !CustomImagesSelectTabComponent && /*#__PURE__*/_react["default"].createElement(_components.UnsplashImagesPicker, {
    accessKey: options.unsplashAccessKey,
    localization: unsplashImagesPickerLocalization,
    onImagesSelected: onImagesSelected,
    maxSelectableImages: options.maxSelectableImages
  }), CustomImagesSelectTabComponent && ResolvedCustomImagesSelectTabComponent))), !CustomFooterComponent && /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Modal.Footer, null, /*#__PURE__*/_react["default"].createElement(_components.UnsplashFooter, {
    footerText: footerText
  })), CustomFooterComponent && ResolvedCustomFooterComponent);
}

ImagePickerModal.propTypes = {
  CustomFooterComponent: _propTypes["default"].node,
  customFooterComponentProps: _propTypes["default"].object,
  CustomHeaderComponent: _propTypes["default"].node,
  customHeaderComponentProps: _propTypes["default"].object,
  CustomImagesSelectTabComponent: _propTypes["default"].node,
  customImagesSelectTabComponentProps: _propTypes["default"].object,
  localization: _propTypes["default"].object,
  onCloseButtonClick: _propTypes["default"].func,
  onImagesSelected: _propTypes["default"].func,
  options: _propTypes["default"].shape({
    accessKey: _propTypes["default"].string.isRequired,
    maxSelectableImages: _propTypes["default"].number
  })
};
ImagePickerModal.defaultProps = {
  localization: {},
  options: {
    accessKey: null,
    // undefined = infinity
    maxSelectableImages: undefined
  }
};

var _default = /*#__PURE__*/_react["default"].memo(ImagePickerModal);

exports["default"] = _default;