"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _emptyResourcePlaceholder = _interopRequireDefault(require("../../../empty-resource-placeholder"));

var EMPTY_SEARCH_TERM_TITLE = 'No images';
var EMPTY_SEARCH_TERM_DESCRIPTION = 'Please enter the search term in the text input and choose your free image';
var EMPTY_SEARCH_RESULTS_TITLE = 'Nothing found';
var EMPTY_SEARCH_RESULTS_DESCRIPTION = 'Please enter a different search term to find images';

function resolveTitle(emptySearchTerm, emptySearchResults, localization) {
  if (emptySearchTerm) {
    return localization.emptySearchTermTitle || EMPTY_SEARCH_TERM_TITLE;
  }

  if (emptySearchResults) {
    return localization.emptySearchResultsTitle || EMPTY_SEARCH_RESULTS_TITLE;
  }

  return '';
}

function resolveDescription(emptySearchTerm, emptySearchResults, localization) {
  if (emptySearchTerm) {
    return localization.emptySearchTermDescription || EMPTY_SEARCH_TERM_DESCRIPTION;
  }

  if (emptySearchResults) {
    return localization.emptySearchResultsDescription || EMPTY_SEARCH_RESULTS_DESCRIPTION;
  }

  return '';
}

function EmptyStateView(_ref) {
  var emptySearchTerm = _ref.emptySearchTerm,
      emptySearchResults = _ref.emptySearchResults,
      localization = _ref.localization;
  return /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement(_emptyResourcePlaceholder["default"], {
    className: "empty-extensions-search-results-placeholder",
    imageSrc: "/img/empty-state-search.svg",
    title: resolveTitle(emptySearchTerm, emptySearchResults, localization),
    imageSize: "144px"
  }, /*#__PURE__*/_react["default"].createElement("span", null, resolveDescription(emptySearchTerm, emptySearchResults, localization))));
}

EmptyStateView.propTypes = {
  emptySearchResults: _propTypes["default"].bool,
  emptySearchTerm: _propTypes["default"].bool,
  localization: _propTypes["default"].object
};
EmptyStateView.defaultProps = {
  emptySearchResults: false,
  emptySearchTerm: false,
  localization: {}
};

var _default = /*#__PURE__*/_react["default"].memo(EmptyStateView);

exports["default"] = _default;