"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _services = require("../../../../services");

require("./style.scss");

function SelectableImagePreview(_ref) {
  var authorName = _ref.authorName,
      authorLink = _ref.authorLink,
      image = _ref.image,
      isSelected = _ref.isSelected,
      localization = _ref.localization,
      onSelectImage = _ref.onSelectImage,
      url = _ref.url;
  var containerClasses = (0, _classnames["default"])('selectable-image-preview__container', {
    'is-selected': isSelected
  });
  var overlayClasses = (0, _classnames["default"])('selectable-image-preview__overlay', {
    'is-selected': isSelected
  });
  var _localization$onText = localization.onText,
      onText = _localization$onText === void 0 ? _services.unsplash.UNSPLASH_CREDIT_ON_TEXT_PART : _localization$onText,
      _localization$photoBy = localization.photoByText,
      photoByText = _localization$photoBy === void 0 ? _services.unsplash.UNSPLASH_CREDIT_BY_TEXT_PART : _localization$photoBy,
      _localization$unsplas = localization.unsplashText,
      unsplashText = _localization$unsplas === void 0 ? _services.unsplash.UNSPLASH_CREDIT_UNSPLASH_TEXT_PART : _localization$unsplas;
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: containerClasses,
    onClick: function onClick() {
      return onSelectImage(image);
    }
  }, /*#__PURE__*/_react["default"].createElement("img", {
    className: "selectable-image-preview__image-preview",
    src: url
  }), /*#__PURE__*/_react["default"].createElement("div", {
    className: overlayClasses
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "selectable-image-preview__image-info-container"
  }, photoByText, /*#__PURE__*/_react["default"].createElement("a", {
    className: "selectable-image-preview__link-text",
    href: authorLink,
    target: "_blank"
  }, ' ', authorName), ' ', onText, ' ', /*#__PURE__*/_react["default"].createElement("a", {
    className: "selectable-image-preview__link-text",
    href: _services.unsplash.HOMEPAGE_URL,
    target: "_blank"
  }, ' ', unsplashText))));
}

SelectableImagePreview.propTypes = {
  authorName: _propTypes["default"].string,
  authorLink: _propTypes["default"].string,
  image: _propTypes["default"].object,
  isSelected: _propTypes["default"].bool,
  onSelectImage: _propTypes["default"].func,
  url: _propTypes["default"].string
};
SelectableImagePreview.defaultProps = {
  isSelected: false,
  localization: {}
};

var _default = /*#__PURE__*/_react["default"].memo(SelectableImagePreview);

exports["default"] = _default;