"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _includes2 = _interopRequireDefault(require("lodash/includes"));

var _map2 = _interopRequireDefault(require("lodash/map"));

var _isEmpty2 = _interopRequireDefault(require("lodash/isEmpty"));

var _forEach2 = _interopRequireDefault(require("lodash/forEach"));

var _react = _interopRequireWildcard(require("react"));

var _react2 = _interopRequireDefault(require("auto-bind/react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactBootstrap = require("react-bootstrap");

var _loader = require("../../../loader");

var _searchInput = _interopRequireDefault(require("../../../search-input"));

var _services = require("../../../../services");

var _selectableImagePreview = _interopRequireDefault(require("../selectable-image-preview"));

var _EmptyStateView = _interopRequireDefault(require("../EmptyStateView"));

require("./style.scss");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var IMAGES_PER_PAGE = 30;
var INSERT_BUTTON_TEXT_SINGULAR = 'Insert image';
var INSERT_BUTTON_TEXT_PLURAL = 'Insert images';
var SEARCH_INPUT_PLACEHOLDER = 'Search';
var MAX_TEXT = 'Max';

function resolveInsertButtonText(maxSelectableImages, singularText, pluralText) {
  if (maxSelectableImages === 1) {
    return singularText;
  }

  return pluralText;
}

var UnsplashImagesPicker = /*#__PURE__*/function (_PureComponent) {
  (0, _inherits2["default"])(UnsplashImagesPicker, _PureComponent);

  var _super = _createSuper(UnsplashImagesPicker);

  function UnsplashImagesPicker(props) {
    var _this;

    (0, _classCallCheck2["default"])(this, UnsplashImagesPicker);
    _this = _super.call(this, props);
    (0, _react2["default"])((0, _assertThisInitialized2["default"])(_this));
    _this.unsplashApi = _services.unsplash.initApi(props.accessKey);
    _this.state = {
      images: [],
      selectedImages: [],
      searchText: '',
      isLoading: false
    };
    return _this;
  }

  (0, _createClass2["default"])(UnsplashImagesPicker, [{
    key: "handleImagesSelected",
    value: function handleImagesSelected() {
      var _this2 = this;

      var onImagesSelected = this.props.onImagesSelected;
      var selectedImages = this.state.selectedImages;
      (0, _forEach2["default"])(selectedImages, function (image) {
        return _services.unsplash.trackImageDownload(_this2.unsplashApi, image.links.download_location);
      });
      onImagesSelected(selectedImages);
    }
  }, {
    key: "handleSearchInputChange",
    value: function handleSearchInputChange(searchQuery) {
      var _this3 = this;

      var searchText = searchQuery.value;

      if ((0, _isEmpty2["default"])(searchText)) {
        return this.setState({
          images: [],
          searchText: '',
          selectedImages: []
        });
      }

      this.setState({
        isLoading: true,
        searchText: searchText
      }, function () {
        _services.unsplash.searchImages(_this3.unsplashApi, searchText, IMAGES_PER_PAGE).then(function (images) {
          return _this3.setState({
            images: images,
            isLoading: false,
            selectedImages: []
          });
        })["catch"](function () {
          return _this3.setState({
            isLoading: false
          });
        });
      });
    }
  }, {
    key: "handleSelectImage",
    value: function handleSelectImage(selectedImage) {
      var maxSelectableImages = this.props.maxSelectableImages;
      var selectedImages = this.state.selectedImages;

      if (maxSelectableImages === 1) {
        return this.setState({
          selectedImages: [selectedImage]
        });
      }

      var newSelectedImages = (0, _toConsumableArray2["default"])(selectedImages);

      if (newSelectedImages.includes(selectedImage)) {
        newSelectedImages = newSelectedImages.filter(function (image) {
          return image !== selectedImage;
        });
        return this.setState({
          selectedImages: newSelectedImages
        });
      }

      if (!maxSelectableImages || newSelectedImages.length < maxSelectableImages) {
        newSelectedImages.push(selectedImage);
        return this.setState({
          selectedImages: newSelectedImages
        });
      }

      return null;
    }
  }, {
    key: "render",
    value: function render() {
      var _this4 = this;

      var _this$props = this.props,
          localization = _this$props.localization,
          maxSelectableImages = _this$props.maxSelectableImages;
      var _this$state = this.state,
          images = _this$state.images,
          isLoading = _this$state.isLoading,
          searchText = _this$state.searchText,
          selectedImages = _this$state.selectedImages;
      var insertButtonDisabled = (0, _isEmpty2["default"])(searchText) || (0, _isEmpty2["default"])(selectedImages);
      var emptySearchTermTitle = localization.emptySearchTermTitle,
          emptySearchTermDescription = localization.emptySearchTermDescription,
          emptySearchResultsTitle = localization.emptySearchResultsTitle,
          emptySearchResultsDescription = localization.emptySearchResultsDescription,
          imagePreviewOnText = localization.imagePreviewOnText,
          imagePreviewPhotoByText = localization.imagePreviewPhotoByText,
          imagePreviewUnsplashText = localization.imagePreviewUnsplashText,
          _localization$insertB = localization.insertButtonTextSingular,
          insertButtonTextSingular = _localization$insertB === void 0 ? INSERT_BUTTON_TEXT_SINGULAR : _localization$insertB,
          _localization$insertB2 = localization.insertButtonTextPlural,
          insertButtonTextPlural = _localization$insertB2 === void 0 ? INSERT_BUTTON_TEXT_PLURAL : _localization$insertB2,
          _localization$invalid = localization.invalidAccessKeyErrorText,
          invalidAccessKeyErrorText = _localization$invalid === void 0 ? _services.unsplash.INVALID_ACCESS_KEY_ERROR_TEXT : _localization$invalid,
          _localization$maxText = localization.maxText,
          maxText = _localization$maxText === void 0 ? MAX_TEXT : _localization$maxText,
          _localization$searchI = localization.searchInputPlaceholder,
          searchInputPlaceholder = _localization$searchI === void 0 ? SEARCH_INPUT_PLACEHOLDER : _localization$searchI;
      var imagePreviewLocalization = {
        onText: imagePreviewOnText,
        photoByText: imagePreviewPhotoByText,
        unsplashText: imagePreviewUnsplashText
      };
      var emptyStateViewLocalization = {
        emptySearchTermTitle: emptySearchTermTitle,
        emptySearchTermDescription: emptySearchTermDescription,
        emptySearchResultsTitle: emptySearchResultsTitle,
        emptySearchResultsDescription: emptySearchResultsDescription
      };

      if (!this.unsplashApi) {
        return /*#__PURE__*/_react["default"].createElement(_reactBootstrap.HelpBlock, null, invalidAccessKeyErrorText);
      }

      var resolvedInsertButtonText = resolveInsertButtonText(maxSelectableImages, insertButtonTextSingular, insertButtonTextPlural);
      var shouldShowMaxSelectableImagesText = maxSelectableImages > 1;
      var maxSelectableImagesText = "".concat(maxText, " ").concat(maxSelectableImages);
      var shouldRenderSearchResults = !(0, _isEmpty2["default"])(images);
      var shouldRenderEmptySearchPlaceholder = (0, _isEmpty2["default"])(images) && (0, _isEmpty2["default"])(searchText);
      var shouldRenderNoSearchResultsPlaceholder = (0, _isEmpty2["default"])(images) && !(0, _isEmpty2["default"])(searchText);
      var shouldRenderEmptyPlaceholder = shouldRenderEmptySearchPlaceholder || shouldRenderNoSearchResultsPlaceholder;
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: "unsplash-images-tab__container"
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: "unsplash-images-tab__search-container"
      }, /*#__PURE__*/_react["default"].createElement(_searchInput["default"], {
        className: "unsplash-images-tab__search-input",
        onChange: this.handleSearchInputChange,
        placeholder: searchInputPlaceholder
      }), /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Button, {
        className: "btn btn-primary",
        disabled: insertButtonDisabled,
        onClick: this.handleImagesSelected
      }, resolvedInsertButtonText), shouldShowMaxSelectableImagesText && /*#__PURE__*/_react["default"].createElement("div", {
        className: "unsplash-images-tab__max-images-text"
      }, maxSelectableImagesText)), /*#__PURE__*/_react["default"].createElement(_loader.LoaderContainer, {
        isLoading: isLoading,
        className: "unsplash-images-tab__results-container",
        size: "50px"
      }, shouldRenderEmptyPlaceholder && /*#__PURE__*/_react["default"].createElement(_EmptyStateView["default"], {
        emptySearchResults: shouldRenderNoSearchResultsPlaceholder,
        emptySearchTerm: shouldRenderEmptySearchPlaceholder,
        localization: emptyStateViewLocalization
      }), shouldRenderSearchResults && (0, _map2["default"])(images, function (imageItem) {
        var authorLink = "".concat(imageItem.user.links.html).concat(_services.unsplash.REFERRAL_URL_SUFIX);
        return /*#__PURE__*/_react["default"].createElement(_selectableImagePreview["default"], {
          image: imageItem,
          authorName: imageItem.user.name,
          authorLink: authorLink,
          isSelected: (0, _includes2["default"])(selectedImages, imageItem),
          localization: imagePreviewLocalization,
          onSelectImage: _this4.handleSelectImage,
          url: imageItem.urls.small
        });
      })));
    }
  }]);
  return UnsplashImagesPicker;
}(_react.PureComponent);

exports["default"] = UnsplashImagesPicker;
(0, _defineProperty2["default"])(UnsplashImagesPicker, "propTypes", {
  accessKey: _propTypes["default"].string.isRequired,
  localization: _propTypes["default"].object,
  maxSelectableImages: _propTypes["default"].number,
  onImagesSelected: _propTypes["default"].func
});
(0, _defineProperty2["default"])(UnsplashImagesPicker, "defaultProps", {
  // undefined = infinity
  maxSelectableImages: undefined,
  localization: {}
});