"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _noop2 = _interopRequireDefault(require("lodash/noop"));

var _isFunction2 = _interopRequireDefault(require("lodash/isFunction"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react2 = _interopRequireDefault(require("auto-bind/react"));

var _classnames2 = _interopRequireDefault(require("classnames"));

var _imageUploader = require("../image-uploader");

var _loader = require("../loader");

var _fontIcon = _interopRequireDefault(require("../font-icon"));

require("./style.scss");

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var ImagePreview = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(ImagePreview, _React$Component);

  var _super = _createSuper(ImagePreview);

  function ImagePreview(props) {
    var _this;

    (0, _classCallCheck2["default"])(this, ImagePreview);
    _this = _super.call(this, props);
    (0, _react2["default"])((0, _assertThisInitialized2["default"])(_this));
    _this.state = {
      inProgress: false
    };
    return _this;
  }

  (0, _createClass2["default"])(ImagePreview, [{
    key: "handleClick",
    value: function handleClick() {
      var _this$props = this.props,
          onClick = _this$props.onClick,
          src = _this$props.src;

      if ((0, _isFunction2["default"])(onClick)) {
        onClick(src);
      }
    }
  }, {
    key: "handleDeleteFailed",
    value: function handleDeleteFailed() {
      var error = (0, _imageUploader.imagePreviewDeleteError)();
      this.setState({
        error: error,
        inProgress: false
      });
      this.props.onDeleteError(error);
    }
  }, {
    key: "handleDelete",
    value: function handleDelete(event) {
      var _this2 = this;

      event.stopPropagation();
      this.setState({
        inProgress: true
      });
      var _this$props2 = this.props,
          src = _this$props2.src,
          onDeleteSuccess = _this$props2.onDeleteSuccess,
          assetManager = _this$props2.assetManager;
      assetManager.deleteFile(src).then(function () {
        _this2.setState({
          inProgress: false
        });

        onDeleteSuccess(src);
      }, this.handleDeleteFailed);
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props3 = this.props,
          src = _this$props3.src,
          className = _this$props3.className,
          onClick = _this$props3.onClick,
          width = _this$props3.width,
          height = _this$props3.height,
          icon = _this$props3.icon,
          previewSize = _this$props3.previewSize,
          canBeDeleted = _this$props3.canBeDeleted,
          deleteStyle = _this$props3.deleteStyle,
          showDeleteError = _this$props3.showDeleteError;
      var deletable = canBeDeleted && !!src;
      var classes = (0, _classnames2["default"])(className, 'image-preview', "image-preview-".concat(previewSize), (0, _defineProperty2["default"])({
        'no-img': !src
      }, "image-preview__".concat(deleteStyle), deletable));
      var style = {
        width: width,
        height: height
      };

      if (!!src) {
        style.backgroundImage = "url('".concat(src, "')");
      }

      if ((0, _isFunction2["default"])(onClick)) {
        style.cursor = 'pointer';
      }

      var loaderClasses = (0, _classnames2["default"])('image-preview__loader', "image-preview__loader-".concat(previewSize));
      return /*#__PURE__*/_react["default"].createElement(_loader.LoaderContainer, {
        className: loaderClasses,
        isLoading: this.state.inProgress
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: classes,
        style: style,
        onClick: this.handleClick
      }, deletable && /*#__PURE__*/_react["default"].createElement(_fontIcon["default"], {
        onClick: this.handleDelete,
        name: deleteStyle
      }), !src && /*#__PURE__*/_react["default"].createElement(_fontIcon["default"], {
        name: icon
      })), showDeleteError && this.state.error && /*#__PURE__*/_react["default"].createElement("div", {
        className: "text-error"
      }, this.state.error));
    }
  }]);
  return ImagePreview;
}(_react["default"].Component);

exports["default"] = ImagePreview;
ImagePreview.propTypes = {
  /**
   * Valid url to the image
   */
  src: _propTypes["default"].string.isRequired,

  /**
   * Additional classes to apply
   */
  className: _propTypes["default"].string,

  /**
   * Click handler. If provided, cursor will be shown on hover
   */
  onClick: _propTypes["default"].func,

  /**
   * Preview width
   */
  width: _propTypes["default"].string,

  /**
   * Preview height
   */
  height: _propTypes["default"].string,

  /**
   * FontIcon name (add-photo, add...)
   */
  icon: _propTypes["default"].string,

  /**
   * Determines image preview block dimensions
   */
  previewSize: _propTypes["default"].oneOf(['small', 'medium', 'large', 'custom']),

  /**
   * Flag indicating whether image can be deleted
   */
  canBeDeleted: _propTypes["default"].bool,

  /**
   *  Callback invoked when image is deleted
   */
  onDeleteSuccess: _propTypes["default"].func,

  /**
   * Defines UI style for hover effect when image can be deleted
   */
  deleteStyle: _propTypes["default"].oneOf(['close', 'delete']),

  /**
   * Object containing methods for uploading, listing, and deleting files on cloud
   */
  assetManager: _propTypes["default"].shape({
    deleteFile: _propTypes["default"].func.isRequired,
    uploadFile: _propTypes["default"].func.isRequired,
    listFolder: _propTypes["default"].func.isRequired
  }),

  /**
   *  Callback invoked when image deletion fails
   */
  onDeleteError: _propTypes["default"].func,

  /**
   * Flag indicating whether to show deletion error in component.
   * If set to false, onDeleteError function should be provided for displaying deletion error.
   */
  showDeleteError: _propTypes["default"].bool
};
ImagePreview.defaultProps = {
  icon: 'add-photo',
  previewSize: 'small',
  deleteStyle: 'delete',
  showDeleteError: true,
  onDeleteError: _noop2["default"]
};