"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.imageDimensionsInvalidError = imageDimensionsInvalidError;
exports.imageDimensionsTooBigError = imageDimensionsTooBigError;
exports.imageDimensionsTooSmallError = imageDimensionsTooSmallError;
exports.imagePreviewDeleteError = imagePreviewDeleteError;
exports.imageSizeTooBigError = imageSizeTooBigError;
exports.imageUploadError = imageUploadError;
exports.imageUploadInvalidType = imageUploadInvalidType;

var _localization = require("./localization");

var _const = require("./const");

function imageDimensionsTooSmallError(width, height) {
  if (width && height) {
    return (0, _localization.getMessage)(_const.IMAGE_UPLOAD_DIMENSIONS_TOO_SMALL, {
      width: width,
      height: height
    });
  }

  if (width) {
    return (0, _localization.getMessage)(_const.IMAGE_UPLOAD_WIDTH_TOO_SMALL, {
      width: width
    });
  }

  if (height) {
    return (0, _localization.getMessage)(_const.IMAGE_UPLOAD_HEIGHT_TOO_SMALL, {
      height: height
    });
  }

  return null;
}

function imageDimensionsTooBigError(width, height) {
  if (width && height) {
    return (0, _localization.getMessage)(_const.IMAGE_UPLOAD_DIMENSIONS_TOO_BIG, {
      width: width,
      height: height
    });
  }

  if (width) {
    return (0, _localization.getMessage)(_const.IMAGE_UPLOAD_WIDTH_TOO_BIG, {
      width: width
    });
  }

  if (height) {
    return (0, _localization.getMessage)(_const.IMAGE_UPLOAD_HEIGHT_TOO_BIG, {
      height: height
    });
  }

  return null;
}

function imageDimensionsInvalidError(width, height) {
  if (width && height) {
    return (0, _localization.getMessage)(_const.IMAGE_UPLOAD_DIMENSIONS_INVALID, {
      width: width,
      height: height
    });
  }

  if (width) {
    return (0, _localization.getMessage)(_const.IMAGE_UPLOAD_WIDTH_INVALID, {
      width: width
    });
  }

  if (height) {
    return (0, _localization.getMessage)(_const.IMAGE_UPLOAD_HEIGHT_INVALID, {
      height: height
    });
  }

  return null;
}

function imageSizeTooBigError(maxSize) {
  return (0, _localization.getMessage)(_const.IMAGE_UPLOAD_SIZE_TOO_BIG, {
    maxSize: maxSize
  });
}

function imageUploadError() {
  return (0, _localization.getMessage)(_const.IMAGE_UPLOAD_ERROR);
}

function imageUploadInvalidType() {
  return (0, _localization.getMessage)(_const.IMAGE_UPLOAD_INVALID_TYPE);
}

function imagePreviewDeleteError() {
  return (0, _localization.getMessage)(_const.IMAGE_PREVIEW_DELETE_ERROR);
}