"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = InfoModal;

var _noop2 = _interopRequireDefault(require("lodash/noop"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactBootstrap = require("react-bootstrap");

function InfoModal(_ref) {
  var title = _ref.title,
      message = _ref.message,
      btnLabel = _ref.btnLabel,
      btnBsStyle = _ref.btnBsStyle,
      onHide = _ref.onHide;
  return /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Modal, {
    show: true,
    onHide: onHide,
    dialogClassName: "info-modal"
  }, /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Modal.Header, null, /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Modal.Title, null, title)), /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Modal.Body, null, /*#__PURE__*/_react["default"].createElement("div", null, message)), /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Modal.Footer, null, /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Button, {
    bsStyle: btnBsStyle,
    onClick: onHide
  }, btnLabel)));
}

InfoModal.defaultProps = {
  btnLabel: 'Close',
  btnBsStyle: 'primary',
  onHide: _noop2["default"]
};
InfoModal.propTypes = {
  /**
   * Title of the info modal content
   */
  title: _propTypes["default"].string,

  /**
   * Content of modal, it can be simple string or component
   */
  message: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].object]),

  /**
   * Display label for button
   */
  btnLabel: _propTypes["default"].string,

  /**
   * Bootstrap style for button
   */
  btnBsStyle: _propTypes["default"].string,

  /**
   * Callback function on `close` button click
   */
  onHide: _propTypes["default"].func
};