"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = InlineModal;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _reactBootstrap = require("react-bootstrap");

var _fontIcon = _interopRequireDefault(require("../font-icon"));

require("./style.scss");

function InlineModal(_ref) {
  var className = _ref.className,
      title = _ref.title,
      onHide = _ref.onHide,
      children = _ref.children,
      show = _ref.show;
  var classes = (0, _classnames["default"])('inline-modal', className);
  return /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Modal, {
    className: classes,
    show: show,
    backdrop: false
  }, /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Modal.Header, null, /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Button, {
    className: "btn-icon pull-left",
    onClick: onHide
  }, /*#__PURE__*/_react["default"].createElement(_fontIcon["default"], {
    name: "back",
    size: "24px"
  })), title && /*#__PURE__*/_react["default"].createElement("h3", {
    className: "inline-modal__title pull-left"
  }, title)), /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Modal.Body, null, children));
}

InlineModal.propTypes = {
  className: _propTypes["default"].string,
  title: _propTypes["default"].string,
  onHide: _propTypes["default"].func,
  children: _propTypes["default"].node,
  show: _propTypes["default"].bool
};
InlineModal.defaultProps = {
  show: true
};