"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = LoaderContainer;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _CircularLoader = _interopRequireDefault(require("./CircularLoader"));

var _excluded = ["isLoading", "className", "children"],
    _excluded2 = ["isLoading", "className", "children", "isOverlay"],
    _excluded3 = ["withoutWrapper"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function renderNoElement(_ref) {
  var isLoading = _ref.isLoading,
      className = _ref.className,
      children = _ref.children,
      props = (0, _objectWithoutProperties2["default"])(_ref, _excluded);
  var classNameMap = (0, _classnames["default"])(className, 'loader-container');

  if (isLoading) {
    return /*#__PURE__*/_react["default"].createElement("div", {
      className: classNameMap
    }, /*#__PURE__*/_react["default"].createElement(_CircularLoader["default"], (0, _extends2["default"])({
      className: "loader"
    }, props)));
  }

  return _react.Children.only(children);
}

function render(_ref2) {
  var isLoading = _ref2.isLoading,
      className = _ref2.className,
      children = _ref2.children,
      isOverlay = _ref2.isOverlay,
      props = (0, _objectWithoutProperties2["default"])(_ref2, _excluded2);
  var classNameMap = (0, _classnames["default"])(className, 'loader-container', {
    'is-overlay': isOverlay && isLoading
  });
  var showChildren = !isLoading || isOverlay;
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: classNameMap
  }, isLoading && /*#__PURE__*/_react["default"].createElement(_CircularLoader["default"], (0, _extends2["default"])({
    className: "loader"
  }, props)), showChildren && children);
}

function LoaderContainer(_ref3) {
  var withoutWrapper = _ref3.withoutWrapper,
      props = (0, _objectWithoutProperties2["default"])(_ref3, _excluded3);

  if (withoutWrapper) {
    return renderNoElement(props);
  }

  return render(props);
}

LoaderContainer.propTypes = {
  className: _propTypes["default"].string,

  /**
   * Indicate to show Loader on true
   */
  isLoading: _propTypes["default"].bool,

  /**
   * children that View wraps
   */
  children: _propTypes["default"].node,

  /**
   * Flag indicating whether loader should hide it's children or just display itself as overlay
   */
  isOverlay: _propTypes["default"].bool,

  /**
   * Flag indicating whether loader should wrap children with <div> wrapper
   */
  withoutWrapper: _propTypes["default"].bool
};
LoaderContainer.defaultProps = {
  isLoading: false
};