"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _isEmpty2 = _interopRequireDefault(require("lodash/isEmpty"));

var _includes2 = _interopRequireDefault(require("lodash/includes"));

var _isFunction2 = _interopRequireDefault(require("lodash/isFunction"));

var _isEqual2 = _interopRequireDefault(require("lodash/isEqual"));

var _map2 = _interopRequireDefault(require("lodash/map"));

var _without2 = _interopRequireDefault(require("lodash/without"));

var _union2 = _interopRequireDefault(require("lodash/union"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react2 = _interopRequireDefault(require("auto-bind/react"));

var _reactBootstrap = require("react-bootstrap");

var _dropdown = _interopRequireDefault(require("../dropdown"));

var _checkbox = _interopRequireDefault(require("../checkbox"));

var _services = require("./services");

require("./style.scss");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var MultiselectDropdown = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(MultiselectDropdown, _Component);

  var _super = _createSuper(MultiselectDropdown);

  function MultiselectDropdown(props) {
    var _this;

    (0, _classCallCheck2["default"])(this, MultiselectDropdown);
    _this = _super.call(this, props);
    (0, _react2["default"])((0, _assertThisInitialized2["default"])(_this));
    var selectedValues = props.selectedValues;
    _this.state = {
      selectedValues: selectedValues
    };
    return _this;
  }

  (0, _createClass2["default"])(MultiselectDropdown, [{
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      var selectedValues = this.props.selectedValues;
      var nextSelectedValues = nextProps.selectedValues;

      if (selectedValues !== nextSelectedValues) {
        this.setState({
          selectedValues: nextSelectedValues
        });
      }
    }
  }, {
    key: "handleItemSelected",
    value: function handleItemSelected(event) {
      var selectedValues = this.state.selectedValues;
      var _event$target = event.target,
          checked = _event$target.checked,
          value = _event$target.value;
      var newSelectedValues = checked ? (0, _union2["default"])(selectedValues, [value]) : (0, _without2["default"])(selectedValues, value);
      this.setState({
        selectedValues: newSelectedValues
      });
    }
  }, {
    key: "handleSelectNone",
    value: function handleSelectNone() {
      this.setState({
        selectedValues: []
      });
    }
  }, {
    key: "handleSelectAll",
    value: function handleSelectAll() {
      var options = this.props.options;
      var selectedValues = (0, _map2["default"])(options, 'value');
      this.setState({
        selectedValues: selectedValues
      });
    }
  }, {
    key: "handleSelectionChanged",
    value: function handleSelectionChanged() {
      var selectedValues = this.state.selectedValues;
      var _this$props = this.props,
          onSelectionChanged = _this$props.onSelectionChanged,
          initialSelectedValues = _this$props.selectedValues;

      if ((0, _isEqual2["default"])(selectedValues, initialSelectedValues)) {
        return;
      }

      onSelectionChanged(selectedValues);
    }
  }, {
    key: "handleToggle",
    value: function handleToggle(isOpen) {
      var onToggle = this.props.onToggle;

      if (!isOpen) {
        this.handleSelectionChanged();
      }

      if ((0, _isFunction2["default"])(onToggle)) {
        onToggle(isOpen);
      }
    }
  }, {
    key: "renderMenuItem",
    value: function renderMenuItem(item) {
      var selectedValues = this.state.selectedValues;
      var value = item.value,
          label = item.label;
      var checked = (0, _includes2["default"])(selectedValues, value);
      return /*#__PURE__*/_react["default"].createElement(_checkbox["default"], {
        checked: checked,
        className: "multiselect-dropdown__checkbox",
        key: value,
        onChange: this.handleItemSelected,
        value: value
      }, label);
    }
  }, {
    key: "render",
    value: function render() {
      var selectedValues = this.state.selectedValues;
      var _this$props2 = this.props,
          options = _this$props2.options,
          displayLabelMaxSelectedOptions = _this$props2.displayLabelMaxSelectedOptions,
          emptyText = _this$props2.emptyText,
          disabled = _this$props2.disabled,
          showSelectNoneOption = _this$props2.showSelectNoneOption,
          showSelectAllOption = _this$props2.showSelectAllOption,
          selectNoneText = _this$props2.selectNoneText,
          selectAllText = _this$props2.selectAllText,
          selectText = _this$props2.selectText;
      var dropdownDisabled = disabled || (0, _isEmpty2["default"])(options);
      var selectedOptionLabel = (0, _services.getDisplayLabel)(options, selectedValues, displayLabelMaxSelectedOptions, emptyText);
      var hasSelectOptions = showSelectAllOption || showSelectNoneOption;
      return /*#__PURE__*/_react["default"].createElement(_dropdown["default"], {
        className: "multiselect-dropdown",
        disabled: dropdownDisabled,
        id: "multiselect-dropdown",
        onToggle: this.handleToggle
      }, /*#__PURE__*/_react["default"].createElement(_dropdown["default"].Toggle, null, selectedOptionLabel), /*#__PURE__*/_react["default"].createElement(_dropdown["default"].Menu, null, /*#__PURE__*/_react["default"].createElement(_reactBootstrap.MenuItem, null, selectedOptionLabel), /*#__PURE__*/_react["default"].createElement(_reactBootstrap.MenuItem, {
        divider: true
      }), hasSelectOptions && /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement("div", {
        className: "select-options"
      }, /*#__PURE__*/_react["default"].createElement("div", null, selectText), showSelectAllOption && /*#__PURE__*/_react["default"].createElement("div", {
        className: "select-option",
        onClick: this.handleSelectAll
      }, selectAllText), showSelectAllOption && showSelectNoneOption && /*#__PURE__*/_react["default"].createElement("span", null, ","), showSelectNoneOption && /*#__PURE__*/_react["default"].createElement("div", {
        className: "select-option",
        onClick: this.handleSelectNone
      }, selectNoneText)), /*#__PURE__*/_react["default"].createElement(_reactBootstrap.MenuItem, {
        divider: true
      })), /*#__PURE__*/_react["default"].createElement("div", {
        className: "multiselect-dropdown__items"
      }, (0, _map2["default"])(options, this.renderMenuItem))));
    }
  }]);
  return MultiselectDropdown;
}(_react.Component);

exports["default"] = MultiselectDropdown;
MultiselectDropdown.propTypes = {
  /**
   * Array of selected option values
   */
  selectedValues: _propTypes["default"].array,

  /**
   * Available dropdown options. Each object must contain `value` and `label` props.
   */
  options: _propTypes["default"].array,

  /**
   * Text that will be shown if no option is selected. Default: `None`.
   */
  emptyText: _propTypes["default"].string,

  /**
   * Dropdown displays all selected options joined by comma (,).
   * As this label can be wider than dropdown's width, with following prop, it can be trimmed.
   * With this prop, you can control how many of selected options will be shown, and others
   * will be represented as `+ {n}` string.
   * For example, if 5 options are currently selected and displayLabelMaxSelectedOptions equals `2`,
   * label will be: `{selectedOption1}, {selectedOption2} + 3`.
   */
  displayLabelMaxSelectedOptions: _propTypes["default"].number,

  /**
   * Optional function for sorting options
   */
  sortBy: _propTypes["default"].func,

  /**
   * Callback function whenever dropdown is closed.
   * Called with array of selected values
   */
  onSelectionChanged: _propTypes["default"].func,

  /**
   * Flag indicating whether dropdown is disabled
   */
  disabled: _propTypes["default"].bool,
  showSelectNoneOption: _propTypes["default"].bool,
  showSelectAllOption: _propTypes["default"].bool,
  selectText: _propTypes["default"].string,
  selectNoneText: _propTypes["default"].string,
  selectAllText: _propTypes["default"].string,
  onToggle: _propTypes["default"].func
};
MultiselectDropdown.defaultProps = {
  selectedValues: [],
  options: [],
  selectText: 'Select',
  emptyText: 'None'
};