"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getDisplayLabel = getDisplayLabel;

var _slice2 = _interopRequireDefault(require("lodash/slice"));

var _size2 = _interopRequireDefault(require("lodash/size"));

var _map2 = _interopRequireDefault(require("lodash/map"));

var _includes2 = _interopRequireDefault(require("lodash/includes"));

var _filter2 = _interopRequireDefault(require("lodash/filter"));

var _isEmpty2 = _interopRequireDefault(require("lodash/isEmpty"));

function getDisplayLabel(options, selectedValues) {
  var maxSelectedOptionsDisplayed = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 1;
  var emptyText = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : 'No data';

  if ((0, _isEmpty2["default"])(options) || (0, _isEmpty2["default"])(selectedValues)) {
    return emptyText;
  }

  var filteredLabels = (0, _filter2["default"])(options, function (option) {
    return (0, _includes2["default"])(selectedValues, option.value);
  });
  var selectedLabels = (0, _map2["default"])(filteredLabels, 'label');

  if ((0, _size2["default"])(selectedLabels) <= maxSelectedOptionsDisplayed) {
    return selectedLabels.join(', ');
  }

  var visibleLabels = (0, _slice2["default"])(selectedLabels, 0, maxSelectedOptionsDisplayed);
  var suffixLabel = "+ ".concat(selectedLabels.length - maxSelectedOptionsDisplayed);
  return "".concat(visibleLabels.join(', '), " ").concat(suffixLabel);
}