"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _get2 = _interopRequireDefault(require("lodash/get"));

var _findIndex2 = _interopRequireDefault(require("lodash/findIndex"));

var _reduce2 = _interopRequireDefault(require("lodash/reduce"));

var _isEmpty2 = _interopRequireDefault(require("lodash/isEmpty"));

var _includes2 = _interopRequireDefault(require("lodash/includes"));

var _has2 = _interopRequireDefault(require("lodash/has"));

var _isEqual2 = _interopRequireDefault(require("lodash/isEqual"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react2 = _interopRequireDefault(require("auto-bind/react"));

var _reactDnd = require("react-dnd");

var _reactDndHtml5Backend = _interopRequireDefault(require("react-dnd-html5-backend"));

var _classnames = _interopRequireDefault(require("classnames"));

var _index = _interopRequireDefault(require("./components/node-draggable/index"));

require("./style.scss");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

/**
 * Component that can be used for rendering nestable list aka trees. It support nesting,
 * different rendering layouts of nodes, DnD, disabling of all functionality per tree or node.
 * NestedSortable DnD is based on React DnD library. Idea is to track all drag nad hover events
 * from DragSource and DropTarget. Based on drag node and hover node and structure of tree,
 * NestedSortable automatically calculates moving in tree persisted in component state.
 * Only on DnD finish, event onDragAndDropComplete is fired with arguments source node
 * and target node as consequence of drag, hover and ultimately drop event.
 * NestedSortable will automatically keep its internal tree structure updated when you
 * drag and drop nodes around. Use onDragAndDropComplete event to update a remote resource
 * (e.g. using api calls) on every tree change. Source and target will be provided as arguments,
 * they both consist of: a node reference and an index. Source object will point to a PARENT of
 * the node which was dragged and index will be the child index in parents children array. On the
 * same note, target will point to the new PARENT of the node that was dragged and index will point
 * to a position in the new parent's children array where the item should be inserted.
 */
var NestedSortable = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(NestedSortable, _Component);

  var _super = _createSuper(NestedSortable);

  function NestedSortable(props) {
    var _this;

    (0, _classCallCheck2["default"])(this, NestedSortable);
    _this = _super.call(this, props);
    (0, _react2["default"])((0, _assertThisInitialized2["default"])(_this));
    _this.state = {
      collapsed: {},
      hoveredId: '',
      isDragging: false
    };
    return _this;
  }

  (0, _createClass2["default"])(NestedSortable, [{
    key: "componentWillMount",
    value: function componentWillMount() {
      this.updateStateWithProps(this.props);
    }
  }, {
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      if (this.state.isDragging) {
        return;
      }

      if (nextProps.selectedId !== this.props.selectedId || !(0, _isEqual2["default"])(this.props.tree, nextProps.tree)) {
        this.updateStateWithProps(nextProps);
      }
    } // eslint-disable-next-line react/sort-comp

  }, {
    key: "updateStateWithProps",
    value: function updateStateWithProps(props) {
      var tree = props.tree,
          selectedId = props.selectedId;
      var nodes = this.createNodeMap(tree);
      var nodeParents = this.createParentNodeMap(tree);
      var selectedNodePredecessors = this.calculateNodePredecessors(selectedId, nodeParents);
      this.setState({
        tree: tree,
        selectedId: selectedId,
        nodes: nodes,
        nodeParents: nodeParents,
        selectedNodePredecessors: selectedNodePredecessors
      });
    }
  }, {
    key: "onToggleCollapse",
    value: function onToggleCollapse(nodeId) {
      var collapsed = _objectSpread(_objectSpread({}, this.state.collapsed), {}, (0, _defineProperty2["default"])({}, nodeId, !this.isCollapsed(nodeId)));

      this.setState({
        collapsed: collapsed
      });
    }
  }, {
    key: "onHoverChange",
    value: function onHoverChange(nodeId, isHover) {
      var hoveredId = isHover ? nodeId : '';
      this.setState({
        hoveredId: hoveredId
      });
    }
  }, {
    key: "onDragAndDropStart",
    value: function onDragAndDropStart() {
      this.setState({
        isDragging: true
      });
    }
  }, {
    key: "onDragAndDropComplete",
    value: function onDragAndDropComplete(source, target) {
      this.setState({
        isDragging: false
      });
      this.props.onDragAndDropComplete(source, target);
    }
  }, {
    key: "isCollapsed",
    value: function isCollapsed(nodeId) {
      var _this$state = this.state,
          collapsed = _this$state.collapsed,
          selectedNodePredecessors = _this$state.selectedNodePredecessors;
      var _this$props = this.props,
          collapseAll = _this$props.collapseAll,
          expandSelectedSubtree = _this$props.expandSelectedSubtree;

      if ((0, _has2["default"])(collapsed, nodeId)) {
        return collapsed[nodeId];
      }

      if (expandSelectedSubtree && (0, _includes2["default"])(selectedNodePredecessors, nodeId)) {
        return false;
      }

      return collapseAll;
    }
  }, {
    key: "isSelected",
    value: function isSelected(nodeId) {
      return this.state.selectedId === nodeId;
    }
  }, {
    key: "isHovered",
    value: function isHovered(nodeId) {
      return this.state.hoveredId === nodeId;
    }
  }, {
    key: "createNodeMap",
    value: function createNodeMap(nodes) {
      var _this2 = this;

      if ((0, _isEmpty2["default"])(nodes)) {
        return {};
      }

      return (0, _reduce2["default"])(nodes, function (result, node) {
        return _objectSpread(_objectSpread({}, result), {}, (0, _defineProperty2["default"])({}, node.id, node), _this2.createNodeMap(node.children));
      }, {});
    }
  }, {
    key: "createParentNodeMap",
    value: function createParentNodeMap(nodes, parentId) {
      var _this3 = this;

      if ((0, _isEmpty2["default"])(nodes)) {
        return {};
      }

      return (0, _reduce2["default"])(nodes, function (result, node) {
        var newResult = _objectSpread(_objectSpread({}, result), _this3.createParentNodeMap(node.children, node.id));

        if (parentId) {
          newResult[node.id] = parentId;
        }

        return newResult;
      }, {});
    }
  }, {
    key: "calculateNodePredecessors",
    value: function calculateNodePredecessors(nodeId, nodeParents) {
      if (!nodeId) {
        return [];
      }

      var nodeParentId = nodeParents[nodeId];

      if (!nodeParentId) {
        return [];
      }

      return [nodeParentId].concat((0, _toConsumableArray2["default"])(this.calculateNodePredecessors(nodeParentId, nodeParents)));
    }
  }, {
    key: "calculateDestination",
    value: function calculateDestination(dragParentNode, dragIndex, hoverParentNode, hoverIndex) {
      var levelChange = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : 0;

      // Checks if all conditions for moving node into nestable node are satisfied
      // and if are, returns destination object that will move node to tail of it's previous
      // sibling children's array. Conditions are based on checking if sibling with
      // index (i-1) exists and does it accepts children, if so we additionally ensure
      // it's not collapsed.
      if (levelChange < 0 && dragParentNode && dragIndex > 0) {
        var previousSiblingNode = dragParentNode.children[dragIndex - 1];
        var isPreviousSiblingNodeCollapsed = this.state.collapsed[previousSiblingNode.id];

        if (previousSiblingNode.isNestable && !isPreviousSiblingNodeCollapsed) {
          return {
            parentNode: previousSiblingNode,
            index: previousSiblingNode.children.length
          };
        }
      } // Checks if all conditions for moving node out from nestable node are satisfied
      // and if are, returns destination object that will move node outside it's parent
      // to become parent's next sibling. Conditions are based on checking if node is
      // last in parent's children array and if grandfather exists (in case of root elements)
      // it doesn't.


      if (levelChange > 0 && dragParentNode) {
        // only last child in nestable node can be dragged one level-up
        var isLast = dragParentNode.children.length === dragIndex + 1;
        var grandParentNodeId = this.state.nodeParents[dragParentNode.id];
        var grandParentNode = grandParentNodeId && this.state.nodes[grandParentNodeId];

        if (isLast && grandParentNode) {
          var parentIndex = (0, _findIndex2["default"])(grandParentNode.children, ['id', dragParentNode.id]);
          return {
            parentNode: grandParentNode,
            index: parentIndex + 1
          };
        }
      } // Normal case based on vertical movement where only information from hoverProps
      // are used to determine destination.


      return {
        parentNode: hoverParentNode,
        index: hoverIndex
      };
    }
  }, {
    key: "updateTree",
    value: function updateTree(sourceNode, sourceIndex, destination) {
      var tree = this.state.tree; // Root nodes have sourceNode undefined, so we use tree as reference to root elements

      var node = sourceNode ? sourceNode.children[sourceIndex] : tree[sourceIndex];
      var sourceNodeChildren = (0, _get2["default"])(sourceNode, 'children', tree);
      var destinationNodeChildren = (0, _get2["default"])(destination, 'parentNode.children', tree); // Moving node by update parents children array

      sourceNodeChildren.splice(sourceIndex, 1);
      destinationNodeChildren.splice(destination.index, 0, node); // Set new state, marking component to re-render

      this.setState({
        tree: tree
      });
    }
  }, {
    key: "moveNode",
    value: function moveNode(dragParentId, dragIndex, hoverParentId, hoverIndex) {
      var levelChange = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : 0;
      // Find parent nodes based on ids
      var dragParentNode = this.state.nodes[dragParentId];
      var hoverParentNode = this.state.nodes[hoverParentId]; // Based on received arguments, calculate destination parameters
      // There are a few patterns that need to be checked
      // If movement isn't possible returns undefined

      var destination = this.calculateDestination(dragParentNode, dragIndex, hoverParentNode, hoverIndex, levelChange); // Cancel move if destination is not feasible

      if (!destination) {
        return null;
      }

      this.updateTree(dragParentNode, dragIndex, destination); // We need to return destination info to NodeDraggable so it can make
      // adjustments on React DnD.

      return {
        index: destination.index,
        parentId: (0, _get2["default"])(destination.parentNode, 'id')
      };
    }
  }, {
    key: "render",
    value: function render() {
      var _this4 = this;

      var nestedSortableClasses = (0, _classnames["default"])(this.props.className, 'nested-sortable');
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: nestedSortableClasses
      }, this.state.tree.map(function (item, i) {
        return /*#__PURE__*/_react["default"].createElement(_index["default"], {
          key: item.id,
          item: item,
          index: i,
          level: 0,
          move: _this4.moveNode,
          isSelected: _this4.isSelected,
          onSelect: _this4.props.onSelect,
          isHorizontal: _this4.props.isHorizontal,
          isHovered: _this4.isHovered,
          onHoverChange: _this4.onHoverChange,
          isCollapsed: _this4.isCollapsed,
          onToggleCollapse: _this4.onToggleCollapse,
          onDragAndDropStart: _this4.onDragAndDropStart,
          onDragAndDropComplete: _this4.onDragAndDropComplete,
          isDraggable: item.isDraggable,
          doesAllowDrop: item.doesAllowDrop,
          isNestable: item.isNestable,
          hasUpdates: item.hasUpdates,
          nodeHeaderTemplate: _this4.props.nodeHeaderTemplate,
          doesParentAllowDrop: !_this4.props.disableDropIntoRoot,
          offset: _this4.props.offset,
          step: _this4.props.step,
          showDragHandle: _this4.props.showDragHandle
        });
      }));
    }
  }]);
  return NestedSortable;
}(_react.Component);

NestedSortable.propTypes = {
  className: _propTypes["default"].string,
  tree: _propTypes["default"].arrayOf(_propTypes["default"].shape({
    id: _propTypes["default"].string.isRequired,
    isNestable: _propTypes["default"].bool,
    hasUpdates: _propTypes["default"].bool,
    isDraggable: _propTypes["default"].bool,
    doesAllowDrop: _propTypes["default"].bool,
    isRoot: _propTypes["default"].bool,
    disableDrop: _propTypes["default"].bool,
    children: _propTypes["default"].array // Node can hold additional attributes that will be used in combination
    // with nodeHeaderTemplate function

  })).isRequired,
  selectedId: _propTypes["default"].string,
  onSelect: _propTypes["default"].func,
  nodeHeaderTemplate: _propTypes["default"].func,
  onDragAndDropComplete: _propTypes["default"].func,
  disableDropIntoRoot: _propTypes["default"].bool,
  offset: _propTypes["default"].number,
  step: _propTypes["default"].number,
  expandSelectedSubtree: _propTypes["default"].bool,
  collapseAll: _propTypes["default"].bool,
  isHorizontal: _propTypes["default"].bool,
  showDragHandle: _propTypes["default"].bool
};
NestedSortable.defaultProps = {
  disableDropIntoRoot: false,
  offset: 8,
  step: 16,
  tree: [],
  isHorizontal: false
};

var _default = new _reactDnd.DragDropContext(_reactDndHtml5Backend["default"])(NestedSortable);

exports["default"] = _default;