"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = NodeChildren;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _index = _interopRequireDefault(require("../node-draggable/index"));

require("./style.scss");

function NodeChildren(props) {
  var isDragging = props.isDragging,
      isParentDragging = props.isParentDragging,
      level = props.level,
      item = props.item,
      isCollapsed = props.isCollapsed;
  var id = item.id,
      children = item.children;
  var isDraggingGreedy = isDragging || isParentDragging;
  var nodeBodyClasses = (0, _classnames["default"])('nested-sortable__node-children', {
    'is-collapsed': isCollapsed(item.id)
  });
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: nodeBodyClasses
  }, children.map(function (child, i) {
    return /*#__PURE__*/_react["default"].createElement(_index["default"], (0, _extends2["default"])({}, props, {
      key: child.id,
      item: child,
      index: i,
      level: level + 1,
      parentId: id,
      isParentDragging: isDraggingGreedy,
      isDraggable: child.isDraggable,
      isNestable: child.isNestable,
      doesParentAllowDrop: !item.disableDrop
    }));
  }));
}

NodeChildren.propTypes = {
  item: _propTypes["default"].object,
  level: _propTypes["default"].number,
  isDragging: _propTypes["default"].bool,
  isParentDragging: _propTypes["default"].bool,
  isCollapsed: _propTypes["default"].func
};