"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react2 = _interopRequireDefault(require("auto-bind/react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _fontIcon = _interopRequireDefault(require("../../../font-icon"));

var _dot = _interopRequireDefault(require("../../../dot"));

var _NodeLevel = _interopRequireDefault(require("./NodeLevel"));

require("./style.scss");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var NodeHeader = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(NodeHeader, _Component);

  var _super = _createSuper(NodeHeader);

  function NodeHeader(props) {
    var _this;

    (0, _classCallCheck2["default"])(this, NodeHeader);
    _this = _super.call(this, props);
    (0, _react2["default"])((0, _assertThisInitialized2["default"])(_this));
    return _this;
  }

  (0, _createClass2["default"])(NodeHeader, [{
    key: "handleClick",
    value: function handleClick() {
      var _this$props = this.props,
          item = _this$props.item,
          onSelect = _this$props.onSelect,
          isSelected = _this$props.isSelected,
          canSelect = _this$props.canSelect,
          onToggleCollapse = _this$props.onToggleCollapse,
          isCollapsible = _this$props.isCollapsible;

      if (!canSelect) {
        return;
      }

      if (isCollapsible && isSelected(item.id)) {
        onToggleCollapse(item.id);
      }

      onSelect(item.id);
    }
  }, {
    key: "handleMouseEnter",
    value: function handleMouseEnter() {
      this.props.onHoverChange(this.props.item.id, true);
    }
  }, {
    key: "handleMouseLeave",
    value: function handleMouseLeave() {
      this.props.onHoverChange(this.props.item.id, false);
    }
  }, {
    key: "handleToggleCollapse",
    value: function handleToggleCollapse(e) {
      this.props.onToggleCollapse(this.props.item.id);
      e.stopPropagation();
    }
  }, {
    key: "renderHandle",
    value: function renderHandle() {
      var nodeHandleClasses = (0, _classnames["default"])('nested-sortable__node-handle', {
        'is-locked': !this.props.isDraggable
      });
      return /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement(_fontIcon["default"], {
        name: "drag-handle",
        className: nodeHandleClasses
      }));
    }
  }, {
    key: "renderCaret",
    value: function renderCaret() {
      var _this$props2 = this.props,
          canCollapse = _this$props2.canCollapse,
          isCollapsible = _this$props2.isCollapsible,
          isCollapsed = _this$props2.isCollapsed,
          item = _this$props2.item;

      if (!canCollapse || !isCollapsible) {
        return null;
      }

      var caretType = isCollapsed(item.id) ? 'sortarrowdown' : 'sortarrowup';
      return /*#__PURE__*/_react["default"].createElement(_fontIcon["default"], {
        className: "nested-sortable__node-caret",
        name: caretType,
        onClick: this.handleToggleCollapse
      });
    }
  }, {
    key: "renderUpdatesDot",
    value: function renderUpdatesDot() {
      var hasUpdates = this.props.hasUpdates;

      if (hasUpdates) {
        return /*#__PURE__*/_react["default"].createElement(_dot["default"], {
          className: "nested-sortable__node-updates-dot"
        });
      }

      return null;
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props3 = this.props,
          isDragging = _this$props3.isDragging,
          isParentDragging = _this$props3.isParentDragging,
          connectDragSource = _this$props3.connectDragSource,
          isHorizontal = _this$props3.isHorizontal,
          isHovered = _this$props3.isHovered,
          isSelected = _this$props3.isSelected,
          canSelect = _this$props3.canSelect,
          item = _this$props3.item,
          level = _this$props3.level,
          step = _this$props3.step,
          offset = _this$props3.offset,
          showDragHandle = _this$props3.showDragHandle;
      var isDraggingGreedy = isDragging || isParentDragging;
      var nodeHeaderClasses = (0, _classnames["default"])('nested-sortable__node-header', {
        'is-selected': isSelected(item.id) && !isDraggingGreedy,
        'is-hover': isHovered(item.id) && !isDraggingGreedy,
        'is-select-disabled': !canSelect,
        'has-drag-handle': showDragHandle
      });
      var nodePlaceholderClasses = (0, _classnames["default"])('nested-sortable__node-placeholder', {
        'is-dragging': isDraggingGreedy,
        'is-horizontal': isHorizontal
      });
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: nodeHeaderClasses,
        onClick: this.handleClick,
        onMouseEnter: this.handleMouseEnter,
        onMouseLeave: this.handleMouseLeave
      }, !isHorizontal && /*#__PURE__*/_react["default"].createElement(_NodeLevel["default"], {
        offset: offset,
        step: step,
        level: level
      }), connectDragSource(this.renderHandle()), /*#__PURE__*/_react["default"].createElement("div", {
        className: nodePlaceholderClasses
      }, this.props.nodeHeaderTemplate(item), this.renderUpdatesDot(), this.renderCaret()));
    }
  }]);
  return NodeHeader;
}(_react.Component);

exports["default"] = NodeHeader;
NodeHeader.propTypes = {
  item: _propTypes["default"].object,
  level: _propTypes["default"].number,
  isDraggable: _propTypes["default"].bool,
  isDragging: _propTypes["default"].bool,
  isParentDragging: _propTypes["default"].bool,
  isSelected: _propTypes["default"].func,
  onSelect: _propTypes["default"].func,
  canSelect: _propTypes["default"].bool,
  isHorizontal: _propTypes["default"].bool,
  isHovered: _propTypes["default"].func,
  onHoverChange: _propTypes["default"].func,
  onToggleCollapse: _propTypes["default"].func,
  isCollapsible: _propTypes["default"].bool,
  isCollapsed: _propTypes["default"].func,
  canCollapse: _propTypes["default"].bool,
  connectDragSource: _propTypes["default"].func,
  nodeHeaderTemplate: _propTypes["default"].func,
  step: _propTypes["default"].number,
  offset: _propTypes["default"].number,
  showDragHandle: _propTypes["default"].bool,
  hasUpdates: _propTypes["default"].bool
};
NodeHeader.defaultProps = {
  canSelect: true,
  canCollapse: true,
  showDragHandle: false,
  hasUpdates: false
};