"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _isUndefined2 = _interopRequireDefault(require("lodash/isUndefined"));

var _ceil2 = _interopRequireDefault(require("lodash/ceil"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react2 = _interopRequireDefault(require("auto-bind/react"));

var _reactBootstrap = require("react-bootstrap");

var _fontIcon = _interopRequireDefault(require("../font-icon"));

require("./style.scss");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function calculatePageCount(itemCount, limit) {
  if (!itemCount) {
    return null;
  }

  if (limit === 0) {
    return 0;
  }

  return (0, _ceil2["default"])(itemCount / limit);
}

function calculatePageIndex(limit, offset) {
  if (limit === 0) {
    return 0;
  }

  return offset / limit;
}

function calculateOffset(limit, pageIndex) {
  return limit * pageIndex;
}

function calculatePageLabel(currentPage, pageCount) {
  if (!pageCount) {
    return "Page ".concat(currentPage);
  }

  return "".concat(currentPage, " of ").concat(pageCount);
}
/**
 * Paging component.
 *
 * Rendered with buttons for jumping to next and previous page.
 * Displays label `n of m` where `n` is current page number and `m` is total page number.
 * Total page number is calculated from props. If it cannot be calculated, displays only `Page n`.
 *
 * Two functions can be called from outside:
 * `reset` - resets paging state to initial
 * `getPagingInfo` - returns current paging limit, offset, pageCount and pageIndex.
 */


var Paging = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(Paging, _Component);

  var _super = _createSuper(Paging);

  function Paging(props) {
    var _this;

    (0, _classCallCheck2["default"])(this, Paging);
    _this = _super.call(this, props);
    (0, _react2["default"])((0, _assertThisInitialized2["default"])(_this));
    return _this;
  }

  (0, _createClass2["default"])(Paging, [{
    key: "componentWillMount",
    value: function componentWillMount() {
      this.checkData(this.props);
    }
  }, {
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      this.checkData(nextProps, this.props);
    } // eslint-disable-next-line react/sort-comp

  }, {
    key: "checkData",
    value: function checkData(nextProps) {
      var props = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
      var nextLimit = nextProps.limit,
          nextOffset = nextProps.offset,
          nextItemCount = nextProps.itemCount;
      var limit = props.limit,
          offset = props.offset,
          itemCount = props.itemCount;
      var pagingHasChanged = nextLimit !== limit || nextOffset !== offset || nextItemCount !== itemCount;

      if (pagingHasChanged) {
        var pageIndex = calculatePageIndex(nextLimit, nextOffset);
        var pageCount = calculatePageCount(nextItemCount, nextLimit);
        this.setState({
          pageIndex: pageIndex,
          pageCount: pageCount
        });
      }
    }
  }, {
    key: "reset",
    value: function reset() {
      var _this$props = this.props,
          itemCount = _this$props.itemCount,
          limit = _this$props.limit,
          offset = _this$props.offset;
      var pageIndex = calculatePageIndex(limit, offset);
      var pageCount = calculatePageCount(itemCount, limit);
      this.setState({
        pageIndex: pageIndex,
        pageCount: pageCount
      });
    }
  }, {
    key: "getPagingInfo",
    value: function getPagingInfo() {
      var limit = this.props.limit;
      var _this$state = this.state,
          pageIndex = _this$state.pageIndex,
          pageCount = _this$state.pageCount;
      var offset = calculateOffset(limit, pageIndex);
      return {
        limit: limit,
        offset: offset,
        pageIndex: pageIndex,
        pageCount: pageCount
      };
    }
  }, {
    key: "hasPreviousPage",
    value: function hasPreviousPage() {
      var hasPrevious = this.props.hasPrevious;
      var pageIndex = this.state.pageIndex;

      if (!(0, _isUndefined2["default"])(hasPrevious)) {
        return hasPrevious;
      }

      return pageIndex > 0;
    }
  }, {
    key: "hasNextPage",
    value: function hasNextPage() {
      var hasNext = this.props.hasNext;
      var _this$state2 = this.state,
          pageCount = _this$state2.pageCount,
          pageIndex = _this$state2.pageIndex;

      if (!(0, _isUndefined2["default"])(hasNext)) {
        return hasNext;
      }

      return !pageCount || pageIndex + 1 < pageCount;
    }
  }, {
    key: "handlePreviousPageClick",
    value: function handlePreviousPageClick() {
      var pageIndex = this.state.pageIndex;

      if (!this.hasPreviousPage()) {
        return;
      }

      this.props.onPreviousPageClick();
      this.setState({
        pageIndex: pageIndex - 1
      });
    }
  }, {
    key: "handleNextPageClick",
    value: function handleNextPageClick() {
      var pageIndex = this.state.pageIndex;

      if (!this.hasNextPage()) {
        return;
      }

      this.props.onNextPageClick();
      this.setState({
        pageIndex: pageIndex + 1
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this$state3 = this.state,
          pageIndex = _this$state3.pageIndex,
          pageCount = _this$state3.pageCount;
      var resolvePageLabel = this.props.resolvePageLabel;
      var hasNext = this.hasNextPage();
      var hasPrevious = this.hasPreviousPage();
      var pageNumber = pageIndex + 1;
      var displayLabel = resolvePageLabel(pageNumber, pageCount);
      return /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Pager, {
        className: "paging pull-right"
      }, /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Pager.Item, {
        className: "paging__item left",
        disabled: !hasPrevious,
        onClick: this.handlePreviousPageClick
      }, /*#__PURE__*/_react["default"].createElement(_fontIcon["default"], {
        name: "arrow-left",
        size: "24px"
      })), /*#__PURE__*/_react["default"].createElement("span", {
        className: "paging__description"
      }, displayLabel), /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Pager.Item, {
        className: "paging__item right",
        disabled: !hasNext,
        onClick: this.handleNextPageClick
      }, /*#__PURE__*/_react["default"].createElement(_fontIcon["default"], {
        name: "arrow-right",
        size: "24px"
      })));
    }
  }]);
  return Paging;
}(_react.Component);

exports["default"] = Paging;
Paging.propTypes = {
  /**
   * Page limit, number of items per page
   */
  limit: _propTypes["default"].number,

  /**
   * Page offset
   */
  offset: _propTypes["default"].number,

  /**
   * Total number of items
   */
  itemCount: _propTypes["default"].number,

  /**
   * Function called when next page is selected
   */
  onNextPageClick: _propTypes["default"].func,

  /**
   * Function called when previous page is selected
   */
  onPreviousPageClick: _propTypes["default"].func,

  /**
   * Flag indicating whether next page exists.
   * If not provided, paging component will calculate this on its own if limit,
   * offset and itemCount are provided.
   */
  hasNext: _propTypes["default"].bool,

  /**
   * Flag indicating whether previous page exists.
   * If not provided, paging component will calculate this on its own if limit,
   * offset and itemCount are provided.
   */
  hasPrevious: _propTypes["default"].bool,

  /**
   * Function used for calculating the display label for the current page.
   * Two input parameters are provided to this component: `currentPage` and `pageCount`.
   * `pageCount` is only provided if it can be calculated (`itemCount` is provided).
   */
  resolvePageLabel: _propTypes["default"].func
};
Paging.defaultProps = {
  limit: 10,
  offset: 0,
  resolvePageLabel: calculatePageLabel
};