"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _noop2 = _interopRequireDefault(require("lodash/noop"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react2 = _interopRequireDefault(require("auto-bind/react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _reactBootstrap = require("react-bootstrap");

var _radio = _interopRequireDefault(require("../radio"));

require("./style.scss");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var RadioSelector = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(RadioSelector, _Component);

  var _super = _createSuper(RadioSelector);

  function RadioSelector(props) {
    var _this;

    (0, _classCallCheck2["default"])(this, RadioSelector);
    _this = _super.call(this, props);
    (0, _react2["default"])((0, _assertThisInitialized2["default"])(_this));
    return _this;
  }

  (0, _createClass2["default"])(RadioSelector, [{
    key: "handleSelect",
    value: function handleSelect(event) {
      var onSelect = this.props.onSelect;
      onSelect(event.target.value);
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props = this.props,
          className = _this$props.className,
          options = _this$props.options,
          activeValue = _this$props.activeValue,
          inline = _this$props.inline,
          groupName = _this$props.groupName,
          radioOptionClassName = _this$props.radioOptionClassName;
      var classes = (0, _classnames["default"])('radio-selector', className);
      return /*#__PURE__*/_react["default"].createElement(_reactBootstrap.FormGroup, {
        className: classes
      }, options.map(function (option) {
        return /*#__PURE__*/_react["default"].createElement(_radio["default"], {
          className: radioOptionClassName,
          inline: inline,
          key: option.value,
          checked: option.value === activeValue,
          name: groupName,
          value: option.value,
          onClick: _this2.handleSelect,
          disabled: option.disabled
        }, option.label);
      }));
    }
  }]);
  return RadioSelector;
}(_react.Component);

exports["default"] = RadioSelector;
RadioSelector.propTypes = {
  /**
   * List of options to display.
   */
  options: _propTypes["default"].arrayOf(_propTypes["default"].shape({
    /**
     * Value will be returned as parameter of onSelect callback
     */
    value: _propTypes["default"].any,

    /**
     * Label displayed on radio button
     */
    label: _propTypes["default"].string,

    /**
     * Indicates whether radio button
     */
    disabled: _propTypes["default"].bool
  })).isRequired,

  /**
   * Active value will select the option with same value
   */
  activeValue: _propTypes["default"].any,
  className: _propTypes["default"].string,
  radioOptionClassName: _propTypes["default"].string,
  inline: _propTypes["default"].bool,
  onSelect: _propTypes["default"].func,

  /**
   * Name for the radio button group
   */
  groupName: _propTypes["default"].string
};
RadioSelector.defaultProps = {
  onSelect: _noop2["default"],
  inline: false,
  groupName: 'radioGroup'
};