"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _toString2 = _interopRequireDefault(require("lodash/toString"));

var _isFunction2 = _interopRequireDefault(require("lodash/isFunction"));

var _get2 = _interopRequireDefault(require("lodash/get"));

var _omit2 = _interopRequireDefault(require("lodash/omit"));

var _react = _interopRequireWildcard(require("react"));

var _react2 = _interopRequireDefault(require("auto-bind/react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactBootstrap = require("react-bootstrap");

var _reactDebounceInput = _interopRequireDefault(require("react-debounce-input"));

var _emojiPicker = _interopRequireDefault(require("../emoji-picker"));

require("./style.scss");

var _excluded = ["debounceTimeout", "disabled", "field", "enableEmojiPicker", "emojiPickerStyle", "emojiIconClassName", "className"],
    _excluded2 = ["className", "elementId", "name", "field", "disabled", "children", "helpText"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var EMOJI_PICKER_STYLE = {
  position: 'absolute',
  zIndex: 7,
  width: 528,
  marginLeft: -528,
  marginTop: 10
};

function fieldInError(formField) {
  return formField.touched && formField.error;
}

var ReduxFormElement = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(ReduxFormElement, _Component);

  var _super = _createSuper(ReduxFormElement);

  function ReduxFormElement(props) {
    var _this;

    (0, _classCallCheck2["default"])(this, ReduxFormElement);
    _this = _super.call(this, props);
    (0, _react2["default"])((0, _assertThisInitialized2["default"])(_this));
    _this.inputRef = /*#__PURE__*/(0, _react.createRef)();
    _this.state = {
      selectionStart: null
    };
    return _this;
  }

  (0, _createClass2["default"])(ReduxFormElement, [{
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.inputRef = null;
    }
  }, {
    key: "getDebouncedInput",
    value: function getDebouncedInput() {
      var _this$props = this.props,
          debounceTimeout = _this$props.debounceTimeout,
          disabled = _this$props.disabled,
          field = _this$props.field,
          enableEmojiPicker = _this$props.enableEmojiPicker,
          emojiPickerStyle = _this$props.emojiPickerStyle,
          emojiIconClassName = _this$props.emojiIconClassName,
          className = _this$props.className,
          otherProps = (0, _objectWithoutProperties2["default"])(_this$props, _excluded);
      var inputClasses = (0, _classnames["default"])('form-control', className, {
        'with-emoji-picker': enableEmojiPicker
      });
      var emojiIconClasses = (0, _classnames["default"])('redux-form-element__emoji-icon', emojiIconClassName);
      var inputProps = (0, _omit2["default"])(_objectSpread(_objectSpread({
        disabled: disabled
      }, field), otherProps), 'className');
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: "redux-form-element__container"
      }, /*#__PURE__*/_react["default"].createElement(_reactDebounceInput["default"], (0, _extends2["default"])({}, inputProps, {
        inputRef: this.inputRef,
        className: inputClasses,
        debounceTimeout: debounceTimeout,
        type: "text"
      })), enableEmojiPicker && /*#__PURE__*/_react["default"].createElement(_emojiPicker["default"], {
        onSelect: this.handleEmojiSelect,
        onToggleEmojiPicker: this.handleEmojiPickerShown,
        iconClassName: emojiIconClasses,
        style: _objectSpread(_objectSpread({}, EMOJI_PICKER_STYLE), emojiPickerStyle)
      }));
    }
  }, {
    key: "handleEmojiPickerShown",
    value: function handleEmojiPickerShown() {
      var input = (0, _get2["default"])(this.inputRef, 'current');

      if (!input) {
        return;
      }

      var selectionStart = input.selectionStart;
      var selectionEnd = input.selectionEnd;

      if ((0, _isFunction2["default"])(input.focus)) {
        input.focus();
      }

      if ((0, _isFunction2["default"])(input.setSelectionRange)) {
        input.setSelectionRange(selectionStart, selectionEnd);
      }
    }
  }, {
    key: "handleEmojiSelect",
    value: function handleEmojiSelect(emoji) {
      var input = (0, _get2["default"])(this.inputRef, 'current');

      if (!input || !emoji) {
        return;
      }

      var inputValue = (0, _toString2["default"])(input.value);
      var selectionStart = input.selectionStart;
      var selectionEnd = input.selectionEnd;
      var textBeforeSelectionStart = inputValue.substring(0, selectionStart);
      var textAfterSelectionEnd = inputValue.substring(selectionEnd, inputValue.length);
      var value = "".concat(textBeforeSelectionStart).concat(emoji["native"]).concat(textAfterSelectionEnd);
      var onChange = (0, _get2["default"])(this.props, 'field.onChange');

      if ((0, _isFunction2["default"])(onChange)) {
        onChange(value);
      }

      if ((0, _isFunction2["default"])(input.focus)) {
        input.focus();
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          className = _this$props2.className,
          elementId = _this$props2.elementId,
          name = _this$props2.name,
          field = _this$props2.field,
          disabled = _this$props2.disabled,
          children = _this$props2.children,
          helpText = _this$props2.helpText,
          otherProps = (0, _objectWithoutProperties2["default"])(_this$props2, _excluded2);
      var isError = fieldInError(field);
      var classes = (0, _classnames["default"])('redux-form-element', className);
      var helpBlockText = isError ? field.error : helpText;
      var child = children || this.getDebouncedInput();

      var childProps = _objectSpread(_objectSpread({
        disabled: disabled
      }, field), otherProps);

      return /*#__PURE__*/_react["default"].createElement(_reactBootstrap.FormGroup, {
        className: classes,
        controlId: elementId,
        validationState: isError ? 'error' : 'success'
      }, /*#__PURE__*/_react["default"].createElement(_reactBootstrap.ControlLabel, null, name), !children && /*#__PURE__*/_react["default"].cloneElement(_react["default"].Children.only(child)), children && /*#__PURE__*/_react["default"].cloneElement(_react["default"].Children.only(child), childProps), helpBlockText && /*#__PURE__*/_react["default"].createElement(_reactBootstrap.HelpBlock, null, helpBlockText));
    }
  }]);
  return ReduxFormElement;
}(_react.Component);

exports["default"] = ReduxFormElement;
ReduxFormElement.propTypes = {
  className: _propTypes["default"].string,
  elementId: _propTypes["default"].string,
  name: _propTypes["default"].string,
  field: _propTypes["default"].object,
  children: _propTypes["default"].node,
  disabled: _propTypes["default"].bool,
  helpText: _propTypes["default"].string,
  onChange: _propTypes["default"].func,
  debounceTimeout: _propTypes["default"].number,
  enableEmojiPicker: _propTypes["default"].bool,
  emojiPickerStyle: _propTypes["default"].object,
  emojiIconClassName: _propTypes["default"].string
};
ReduxFormElement.defaultProps = {
  debounceTimeout: 500,
  enableEmojiPicker: false
};