"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _noop2 = _interopRequireDefault(require("lodash/noop"));

var _first2 = _interopRequireDefault(require("lodash/first"));

var _isFunction2 = _interopRequireDefault(require("lodash/isFunction"));

var _map2 = _interopRequireDefault(require("lodash/map"));

var _isEmpty2 = _interopRequireDefault(require("lodash/isEmpty"));

var _get2 = _interopRequireDefault(require("lodash/get"));

var _react = _interopRequireWildcard(require("react"));

var _react2 = _interopRequireDefault(require("auto-bind/react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _suneditorReact = _interopRequireDefault(require("suneditor-react"));

var _services = require("../../services");

var _emojiPicker = _interopRequireDefault(require("../emoji-picker"));

var _imagePickerModal = _interopRequireDefault(require("../image-picker-modal"));

var _const = require("./const");

var _customPlugins = _interopRequireDefault(require("./customPlugins"));

require("suneditor/dist/css/suneditor.min.css");

require("./style.scss");

var _excluded = ["enableImageAlign", "enableImageDescription", "enableImageFormatting", "enableImagePickerImageSearch", "enableVideoAlign", "imagePickerLocalization", "imagePickerOptions"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var EMOJI_PICKER_STYLE = {
  position: 'absolute',
  zIndex: 6,
  width: 300,
  top: 183,
  right: 12
};

var RichTextEditor = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(RichTextEditor, _Component);

  var _super = _createSuper(RichTextEditor);

  function RichTextEditor(props) {
    var _this;

    (0, _classCallCheck2["default"])(this, RichTextEditor);
    _this = _super.call(this, props);
    (0, _react2["default"])((0, _assertThisInitialized2["default"])(_this));
    var enableImageUpload = props.enableImageUpload,
        initialValue = props.value;
    _this.editorRef = /*#__PURE__*/(0, _react.createRef)();
    _this.emojiPickerRef = /*#__PURE__*/(0, _react.createRef)(); // Resolve plugins (toolbar options)

    var plugins = []; // if there is no unsplashAccessKey, do not create image plugin

    var unsplashAccessKey = (0, _get2["default"])(_this.props, 'imagePickerOptions.unsplashAccessKey');

    if (!(0, _isEmpty2["default"])(unsplashAccessKey)) {
      plugins.push(_customPlugins["default"].initImagesCC(_this.handleShowImagePickerModal));
    }

    plugins.push(_customPlugins["default"].initEmojiPicker(_this.handleToggleEmojiPicker));
    var allPlugins = [].concat(plugins, (0, _toConsumableArray2["default"])(props.customPlugins));
    _this.editorOptions = (0, _const.resolveEditorOptions)(allPlugins, {
      enableImageUpload: enableImageUpload
    });
    _this.state = {
      rteValue: initialValue,
      showImagePickerModal: false
    };
    return _this;
  }

  (0, _createClass2["default"])(RichTextEditor, [{
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.editorRef = null;
      this.emojiPickerRef = null;
    }
  }, {
    key: "handleValueChanged",
    value: function handleValueChanged(rteValue) {
      var onChange = this.props.onChange;
      this.setState({
        rteValue: rteValue
      }, function () {
        return onChange(rteValue);
      });
    }
  }, {
    key: "handleEmojiSelect",
    value: function handleEmojiSelect(emoji) {
      var onChange = this.props.onChange;
      var rteValue = this.state.rteValue;

      if (!emoji) {
        return;
      }

      this.setState({
        rteValue: rteValue + emoji["native"]
      }, function () {
        return onChange(rteValue + emoji["native"]);
      });
    }
  }, {
    key: "handleShowImagePickerModal",
    value: function handleShowImagePickerModal() {
      this.setState({
        showImagePickerModal: true
      });
    }
  }, {
    key: "handleHideImagePickerModal",
    value: function handleHideImagePickerModal() {
      this.setState({
        showImagePickerModal: false
      });
    }
  }, {
    key: "handleImagesSelected",
    value: function handleImagesSelected(images) {
      var _this2 = this;

      var onChange = this.props.onChange;
      var rteValue = this.state.rteValue;
      var imagesHtml = (0, _map2["default"])(images, function (selectedImage) {
        var image = {
          id: (0, _get2["default"])(selectedImage, 'id'),
          user: {
            name: (0, _get2["default"])(selectedImage, 'user.name'),
            profileUrl: (0, _get2["default"])(selectedImage, 'user.links.html')
          },
          url: (0, _get2["default"])(selectedImage, 'urls.full')
        };
        return _services.unsplash.imageWithDescriptionHtml(image);
      });
      var imagesHtmlString = imagesHtml.join('');
      this.setState({
        rteValue: rteValue + imagesHtmlString
      }, function () {
        onChange(rteValue + imagesHtmlString);

        _this2.handleHideImagePickerModal();
      });
    }
  }, {
    key: "handleToggleEmojiPicker",
    value: function handleToggleEmojiPicker() {
      this.emojiPickerRef.current.handleToggleEmojiPicker();
    }
  }, {
    key: "handleHideEmojiPicker",
    value: function handleHideEmojiPicker() {
      this.emojiPickerRef.current.hide();
    }
  }, {
    key: "handleSunEditorInstance",
    value: function handleSunEditorInstance(suneditor) {
      this.editorRef.current = suneditor;
    }
  }, {
    key: "handleImageUpload",
    value: function () {
      var _handleImageUpload = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee(file, uploadHandler) {
        var onImageUpload, url, res;
        return _regenerator["default"].wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                onImageUpload = this.props.onImageUpload;

                if ((0, _isFunction2["default"])(onImageUpload)) {
                  _context.next = 3;
                  break;
                }

                return _context.abrupt("return");

              case 3:
                _context.next = 5;
                return onImageUpload(file);

              case 5:
                url = _context.sent;

                if (url) {
                  _context.next = 9;
                  break;
                }

                uploadHandler();
                return _context.abrupt("return");

              case 9:
                res = {
                  result: [{
                    url: url,
                    name: file.name
                  }]
                };
                uploadHandler(res);

              case 11:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function handleImageUpload(_x, _x2) {
        return _handleImageUpload.apply(this, arguments);
      }

      return handleImageUpload;
    }()
  }, {
    key: "handleOnImageUploadBefore",
    value: function handleOnImageUploadBefore(files, info, uploadHandler) {
      var enableImageUpload = this.props.enableImageUpload;

      if (enableImageUpload) {
        var file = (0, _first2["default"])(files);

        if (!file) {
          return false;
        }

        this.handleImageUpload(file, uploadHandler);
        return undefined;
      }

      return false;
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          enableImageAlign = _this$props.enableImageAlign,
          enableImageDescription = _this$props.enableImageDescription,
          enableImageFormatting = _this$props.enableImageFormatting,
          enableImagePickerImageSearch = _this$props.enableImagePickerImageSearch,
          enableVideoAlign = _this$props.enableVideoAlign,
          imagePickerLocalization = _this$props.imagePickerLocalization,
          imagePickerOptions = _this$props.imagePickerOptions,
          otherProps = (0, _objectWithoutProperties2["default"])(_this$props, _excluded);
      var _this$state = this.state,
          rteValue = _this$state.rteValue,
          showImagePickerModal = _this$state.showImagePickerModal;
      var classes = (0, _classnames["default"])('rich-text-editor__container', {
        'no-image-formatting': !enableImageFormatting,
        'no-image-description': !enableImageDescription,
        'no-image-align': !enableImageAlign,
        'no-video-align': !enableVideoAlign
      });
      var shouldShowImagePicker = enableImagePickerImageSearch && showImagePickerModal;
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: classes
      }, /*#__PURE__*/_react["default"].createElement(_emojiPicker["default"], {
        ref: this.emojiPickerRef,
        onSelect: this.handleEmojiSelect,
        showTogglePickerButton: false,
        style: EMOJI_PICKER_STYLE
      }), shouldShowImagePicker && /*#__PURE__*/_react["default"].createElement(_imagePickerModal["default"], {
        options: imagePickerOptions,
        localization: imagePickerLocalization,
        onCloseButtonClick: this.handleHideImagePickerModal,
        onImagesSelected: this.handleImagesSelected
      }), /*#__PURE__*/_react["default"].createElement(_suneditorReact["default"], (0, _extends2["default"])({}, otherProps, {
        getSunEditorInstance: this.handleSunEditorInstance,
        setContents: rteValue,
        onClick: this.handleHideEmojiPicker,
        onChange: this.handleValueChanged,
        onImageUploadBefore: this.handleOnImageUploadBefore,
        onImageUpload: _noop2["default"],
        setOptions: this.editorOptions
      })));
    }
  }]);
  return RichTextEditor;
}(_react.Component);

exports["default"] = RichTextEditor;
RichTextEditor.propTypes = {
  customPlugins: _propTypes["default"].array,
  enableImageUpload: _propTypes["default"].bool,
  enableImageAlign: _propTypes["default"].bool,
  enableImageDescription: _propTypes["default"].bool,
  enableImageFormatting: _propTypes["default"].bool,
  enableImagePickerImageSearch: _propTypes["default"].bool,
  enableVideoAlign: _propTypes["default"].bool,
  imagePickerLocalization: _propTypes["default"].object,
  imagePickerOptions: _propTypes["default"].object,
  onChange: _propTypes["default"].func.isRequired,
  onImageUpload: _propTypes["default"].func,
  value: _propTypes["default"].string.isRequired
};
RichTextEditor.defaultProps = {
  customPlugins: [],
  enableImageUpload: false,
  enableImageAlign: false,
  enableImageDescription: false,
  enableImageFormatting: false,
  enableImagePickerImageSearch: true,
  enableVideoAlign: false,
  imagePickerLocalization: {},
  imagePickerOptions: {}
};