"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.resolveEditorOptions = resolveEditorOptions;

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _find2 = _interopRequireDefault(require("lodash/find"));

var _forEach2 = _interopRequireDefault(require("lodash/forEach"));

var _plugins = _interopRequireDefault(require("suneditor/src/plugins"));

var _customPlugins = require("./customPlugins");

function resolveEditorOptions(customPlugins) {
  var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var attachmentsButtonList = ['link', 'video', 'image'];
  var resolvedPlugins = (0, _toConsumableArray2["default"])(customPlugins);
  var enableImageUpload = options.enableImageUpload;
  (0, _forEach2["default"])(_plugins["default"], function (plugin) {
    var item = (0, _find2["default"])(customPlugins, {
      name: plugin.name
    });

    if (!item) {
      resolvedPlugins.push(plugin);
    }
  });
  var imagesCCcustomPluginExist = (0, _find2["default"])(customPlugins, {
    name: _customPlugins.IMAGESCC_CUSTOM_PLUGIN
  });

  if (imagesCCcustomPluginExist) {
    attachmentsButtonList.push({
      name: _customPlugins.IMAGESCC_CUSTOM_PLUGIN,
      dataCommand: _customPlugins.IMAGESCC_CUSTOM_PLUGIN,
      title: 'Image',
      dataDisplay: 'command',
      innerHTML: '<span class="font-icon se-icon se-icon-imagecreativecommons" style="font-size: 24px;"></span>'
    });
  }

  return {
    plugins: resolvedPlugins,
    height: 300,
    defaultTag: 'div',
    textTags: {
      strike: 's'
    },
    imageRotation: false,
    mediaAutoSelect: false,
    videoResizing: false,
    formats: ['div', 'p', 'h1', 'h2', 'h3', 'h4', 'h5', 'h6'],
    imageFileInput: !!enableImageUpload,
    imageMultipleFile: false,
    linkProtocol: 'https://',
    buttonList: [['undo', 'redo', 'removeFormat'], ['-right', 'fullScreen', 'codeView'], '/', ['fontSize', 'formatBlock', 'bold', 'underline', 'italic', 'strike', 'fontColor', 'hiliteColor', 'outdent', 'indent'], ['align', 'list', 'table'], attachmentsButtonList, [{
      name: 'emojiCustomPlugin',
      dataCommand: 'emojiCustomPlugin',
      buttonClass: '',
      title: 'Emoji',
      dataDisplay: 'command',
      innerHTML: '<span class="font-icon se-icon se-icon-emoticon" style="font-size: 24px;"></span>'
    }]]
  };
}