"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _noop2 = _interopRequireDefault(require("lodash/noop"));

var _omit2 = _interopRequireDefault(require("lodash/omit"));

var _escapeRegExp2 = _interopRequireDefault(require("lodash/escapeRegExp"));

var _debounce2 = _interopRequireDefault(require("lodash/debounce"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react2 = _interopRequireDefault(require("auto-bind/react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _actionInput = _interopRequireDefault(require("../action-input"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var SearchInput = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(SearchInput, _Component);

  var _super = _createSuper(SearchInput);

  function SearchInput(props) {
    var _this;

    (0, _classCallCheck2["default"])(this, SearchInput);
    _this = _super.call(this, props);
    (0, _react2["default"])((0, _assertThisInitialized2["default"])(_this));
    var value = props.value,
        regexValue = props.regexValue;
    _this.searchControlInputRef = /*#__PURE__*/(0, _react.createRef)();
    _this.handleInputChanged = (0, _debounce2["default"])(_this.handleInputChanged, 250);
    _this.state = {
      value: value,
      regexValue: regexValue
    };
    return _this;
  }

  (0, _createClass2["default"])(SearchInput, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var autoFocus = this.props.autoFocus;

      if (autoFocus) {
        this.focus();
      }
    }
  }, {
    key: "focus",
    value: function focus() {
      this.searchControlInputRef.current.focus();
    }
  }, {
    key: "handleInputChange",
    value: function handleInputChange(event) {
      var value = event.target.value;
      var regexValue = new RegExp((0, _escapeRegExp2["default"])(value), 'ig');
      this.setState({
        value: value,
        regexValue: regexValue
      }, this.handleInputChanged);
    }
  }, {
    key: "handleInputChanged",
    value: function handleInputChanged() {
      var _this$state = this.state,
          value = _this$state.value,
          regexValue = _this$state.regexValue;
      this.props.onChange({
        value: value,
        regexValue: regexValue
      });
    }
  }, {
    key: "render",
    value: function render() {
      var className = this.props.className;
      var otherProps = (0, _omit2["default"])(this.props, ['className', 'onChange']);
      var classes = (0, _classnames["default"])('search-input', className);
      return /*#__PURE__*/_react["default"].createElement(_actionInput["default"], (0, _extends2["default"])({
        type: "search",
        className: classes,
        onChange: this.handleInputChange,
        ref: this.searchControlInputRef
      }, otherProps), /*#__PURE__*/_react["default"].createElement(_actionInput["default"].Left, {
        icon: "search",
        onClick: _noop2["default"]
      }));
    }
  }]);
  return SearchInput;
}(_react.Component);

exports["default"] = SearchInput;
SearchInput.propTypes = {
  autoFocus: _propTypes["default"].bool,

  /**
   * Additional class name to be passed to react component
   */
  className: _propTypes["default"].string,

  /**
   * Function called when input is changed (with debounce of 250ms)
   */
  onChange: _propTypes["default"].func,
  value: _propTypes["default"].string,
  regexValue: _propTypes["default"].string
};
SearchInput.defaultProps = {
  autoFocus: false,
  value: null,
  regexValue: null
};