"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = StepIndicator;

var _map2 = _interopRequireDefault(require("lodash/map"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _fontIcon = _interopRequireDefault(require("../font-icon"));

require("./style.scss");

function StepIndicator(_ref) {
  var steps = _ref.steps,
      className = _ref.className,
      _onClick = _ref.onClick,
      activeValue = _ref.activeValue;
  var stepIndicatorClasses = (0, _classnames["default"])('step-indicator', className);
  var reachedActiveStep = false;
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: stepIndicatorClasses
  }, (0, _map2["default"])(steps, function (step, index) {
    var label = step.label,
        value = step.value;
    var stepNumber = index + 1;
    var isLastItem = stepNumber === steps.length;
    var isActiveStep = value === activeValue;
    var isCompleted = !isActiveStep && !reachedActiveStep;

    if (isActiveStep) {
      reachedActiveStep = true;
    }

    var containerClasses = (0, _classnames["default"])('step-indicator__container', {
      'full-width': !isLastItem
    });
    var stepClasses = (0, _classnames["default"])('step-indicator__step', {
      'is-active-step': isActiveStep,
      'is-completed-step': isCompleted
    });
    var stepLineClasses = (0, _classnames["default"])('step-indicator__step-line', {
      'is-active-step': isActiveStep,
      'is-completed-step': isCompleted
    });
    var stepTitleClasses = (0, _classnames["default"])('step-indicator__step-title', {
      'is-active-step': isActiveStep,
      'is-completed-step': isCompleted
    });
    return /*#__PURE__*/_react["default"].createElement("div", {
      className: containerClasses,
      key: value
    }, /*#__PURE__*/_react["default"].createElement("div", {
      className: "step-indicator__col"
    }, /*#__PURE__*/_react["default"].createElement("div", {
      className: stepClasses
    }, !isCompleted && stepNumber, isCompleted && /*#__PURE__*/_react["default"].createElement(_fontIcon["default"], {
      name: "check",
      className: "step-indicator__completed_icon",
      size: "22px"
    })), /*#__PURE__*/_react["default"].createElement("div", {
      className: stepTitleClasses
    }, !isCompleted && label, isCompleted && /*#__PURE__*/_react["default"].createElement("span", {
      onClick: function onClick() {
        return _onClick(value);
      }
    }, label))), !isLastItem && /*#__PURE__*/_react["default"].createElement("div", {
      className: stepLineClasses
    }));
  }));
}

StepIndicator.propTypes = {
  steps: _propTypes["default"].array,
  className: _propTypes["default"].string,
  onClick: _propTypes["default"].func,
  activeValue: _propTypes["default"].string
};