"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _omit2 = _interopRequireDefault(require("lodash/omit"));

var _uniqueId2 = _interopRequireDefault(require("lodash/uniqueId"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react2 = _interopRequireDefault(require("auto-bind/react"));

var _classnames = _interopRequireDefault(require("classnames"));

require("./style.scss");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var Switch = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(Switch, _Component);

  var _super = _createSuper(Switch);

  function Switch(props) {
    var _this;

    (0, _classCallCheck2["default"])(this, Switch);
    _this = _super.call(this, props);
    (0, _react2["default"])((0, _assertThisInitialized2["default"])(_this));
    _this.state = {
      switchId: (0, _uniqueId2["default"])('switch__'),
      checked: !!props.value
    };
    return _this;
  }

  (0, _createClass2["default"])(Switch, [{
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      var nextValue = nextProps.value;
      var value = this.props.value;

      if (nextValue !== value) {
        this.setState({
          checked: !!nextValue
        });
      }
    }
  }, {
    key: "handleToggleSwitch",
    value: function handleToggleSwitch(e) {
      var checked = this.state.checked;
      var onChange = this.props.onChange;
      this.setState({
        checked: !checked
      });
      onChange(e);
    }
  }, {
    key: "renderSwitchButton",
    value: function renderSwitchButton() {
      var otherProps = (0, _omit2["default"])(this.props, ['className', 'children']);
      var _this$state = this.state,
          checked = _this$state.checked,
          switchId = _this$state.switchId;
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: "switch__button"
      }, /*#__PURE__*/_react["default"].createElement("input", (0, _extends2["default"])({
        type: "checkbox",
        id: switchId,
        checked: checked,
        onChange: this.handleToggleSwitch
      }, otherProps)), /*#__PURE__*/_react["default"].createElement("label", {
        htmlFor: switchId
      }), /*#__PURE__*/_react["default"].createElement("div", {
        className: "switch__knob"
      }), /*#__PURE__*/_react["default"].createElement("div", {
        className: "switch__knob-background"
      }));
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          className = _this$props.className,
          children = _this$props.children;
      var classNameMap = (0, _classnames["default"])('switch', className);
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: classNameMap
      }, children, this.renderSwitchButton());
    }
  }]);
  return Switch;
}(_react.Component);

exports["default"] = Switch;
Switch.propTypes = {
  value: _propTypes["default"].bool,
  className: _propTypes["default"].string,
  onChange: _propTypes["default"].func,
  children: _propTypes["default"].node
};