"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _get2 = _interopRequireDefault(require("lodash/get"));

var _unsplashJs = require("unsplash-js");

var _unsplashLogo = _interopRequireDefault(require("../img/unsplash-logo.png"));

var REFERRAL_URL_SUFIX = '/?utm_source=Shoutem&utm_medium=referral';
var HOMEPAGE_URL = "https://www.unsplash.com".concat(REFERRAL_URL_SUFIX);
var INVALID_ACCESS_KEY_ERROR_TEXT = 'Invalid Unsplash access key';
var UNSPLASH_CREDIT_ON_TEXT_PART = 'on';
var UNSPLASH_CREDIT_BY_TEXT_PART = 'Photo by';
var UNSPLASH_CREDIT_UNSPLASH_TEXT_PART = ' Unsplash';

function initApi(accessKey) {
  if (accessKey) {
    return (0, _unsplashJs.createApi)({
      accessKey: accessKey
    });
  }

  return null;
}

function searchImages(_x, _x2, _x3) {
  return _searchImages.apply(this, arguments);
}

function _searchImages() {
  _searchImages = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee(api, query, perPage) {
    var result;
    return _regenerator["default"].wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.prev = 0;
            _context.next = 3;
            return api.search.getPhotos({
              query: query,
              perPage: perPage
            });

          case 3:
            result = _context.sent;
            return _context.abrupt("return", (0, _get2["default"])(result, 'response.results', []));

          case 7:
            _context.prev = 7;
            _context.t0 = _context["catch"](0);
            return _context.abrupt("return", []);

          case 10:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, null, [[0, 7]]);
  }));
  return _searchImages.apply(this, arguments);
}

function trackImageDownload(api, downloadLocation) {
  api.photos.trackDownload({
    downloadLocation: downloadLocation
  });
}

function imageWithDescriptionHtml(image) {
  return "<div\n      id=\"unsplash-image-container\"\n      class=\"se-component se-image-container __se__float-none\"\n      contenteditable=\"false\"\n      style=\"display: flex; flex-direction: column; align-items: center;\"\n    >\n      <figure style=\"display: flex; flex-direction: column; justify-content: center; align-items: center;\">\n        <img\n          id=\"unsplash-image\"\n          src=".concat(image.url, "\n          data-proportion=\"true\"\n          data-file-name=\"").concat(image.id, ".png\"\n          style=\"width: 475px;\"\n        />\n        <div id=\"unsplash-image-description-container\"><span>Photo by <a href=\"").concat(image.user.profileUrl).concat(REFERRAL_URL_SUFIX, "\" target=\"_blank\">").concat(image.user.name, "</a> on <a href=\"").concat(HOMEPAGE_URL, "\" target=\"_blank\">Unsplash</a></span></div>\n        </figure>\n        </div><br>");
}

var _default = {
  HOMEPAGE_URL: HOMEPAGE_URL,
  imageWithDescriptionHtml: imageWithDescriptionHtml,
  initApi: initApi,
  INVALID_ACCESS_KEY_ERROR_TEXT: INVALID_ACCESS_KEY_ERROR_TEXT,
  logo: _unsplashLogo["default"],
  REFERRAL_URL_SUFIX: REFERRAL_URL_SUFIX,
  searchImages: searchImages,
  trackImageDownload: trackImageDownload,
  UNSPLASH_CREDIT_ON_TEXT_PART: UNSPLASH_CREDIT_ON_TEXT_PART,
  UNSPLASH_CREDIT_BY_TEXT_PART: UNSPLASH_CREDIT_BY_TEXT_PART,
  UNSPLASH_CREDIT_UNSPLASH_TEXT_PART: UNSPLASH_CREDIT_UNSPLASH_TEXT_PART
};
exports["default"] = _default;